module control
! declare the file name for storing the model data
	character*30 FName,FCut0,FCut,FOut
    character*80 ftitle,fip
! declare some integer for using
	integer NAtoms,scales,n
!    character phase
	real,dimension(3) :: ModelSize
	real,dimension(3) :: BasePoint
	real,dimension(9) :: cell1
	real GridSize,deltat
!	INTEGER, DIMENSION(10) :: nsolute,typ
!	INTEGER, DIMENSION(10, 1000) :: Isolution
	INTEGER, DIMENSION(3) :: MCell
	real, dimension(:,:), allocatable :: pos     ! positions
	INTEGER, DIMENSION(:), allocatable :: ScaleIndex
	INTEGER, DIMENSION(:), allocatable :: AtomTypeIndex
!    INTEGER, DIMENSION(:), allocatable :: ISolution
    INTEGER, DIMENSION(:), allocatable :: IVacancy
	INTEGER, DIMENSION(:), allocatable :: HEAD
	INTEGER, DIMENSION(:), allocatable :: List
	INTEGER, DIMENSION(:), allocatable :: NeighborList
	integer, dimension (:), allocatable :: Marker1, Marker2
	integer,parameter :: MaxPairsPerAtom=50
	integer MaxListLength
	integer levfg,imcon, ntotal
end module control

subroutine BasicBccCell
open(1,file='BasicCell.bcc')
write(1,'(3f24.15,i6)') 0.0,0.0,0.0,1
write(1,'(3f24.15,i6)') 0.5,0.5,0.5,1
close(1)
end subroutine BasicBccCell

subroutine CellBcc							! Tool to check how many atoms in primitive cell
real :: base(3,3),R
real :: x0,y0,z0,x,y,z
integer i,j,k,n,depth,typ
real, parameter :: a0=2.92   !2.87   ! iron
!real, parameter :: a0=4.05 
!real, parameter :: a0=3.62     ! Copper
real, parameter :: a=1.0
real, parameter :: b=1.0
real, parameter :: c=1.0
open(1,file='cell.bcc')
base(1,1)=1.0
base(1,2)=0.0
base(1,3)=0.0
base(2,1)=0.0
base(2,2)=1.0
base(2,3)=0.0
base(3,1)=0.0
base(3,2)=0.0
base(3,3)=1.1
R=sqrt(11.)
depth=int(R)+1
n=0
do k=-depth,depth
   do i=-depth,depth
	do j=-depth,depth
			x=float(i)
			y=float(j)
			z=float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c                                                             
			typ=3
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
			x=float(i)+0.5d0
			y=float(j)+0.5d0
			z=float(k)+0.5d0
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c                                                             
			typ=3
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
		enddo
	enddo
enddo
close(1)
print *,n
end subroutine CellBcc						! Tool to check how many atoms in primitive cell

!F Following is added for fcc (represented by "Y")

subroutine CellFcc							! Tool to check how many atoms in primitive cell
real :: base(3,3),R
real :: x0,y0,z0,x,y,z
integer i,j,k,n,depth,typ
real, parameter :: a0=4.0559   ! Aluminum
!real, parameter :: a0=3.629     ! Copper
! real, parameter :: a0=2.92    ! iron
! for setting of [0-1-1],[1-1-1], [211]
!real, parameter :: a=1.4142
!real, parameter :: b=1.7321
!real, parameter :: c=2.4495
!for setting of [110], [-11-2], [-111] - Chen
!real, parameter :: a=1.4142
!real, parameter :: b=2.4495       !1.7321
!real, parameter :: c=1.7321
! for setting of [111],[11 -2], [-110]  -MSU
!real, parameter :: a=1.7321     !1.4142   
!real, parameter :: b=2.4495     !1.7321 
!real, parameter :: c=1.4142     !2.4495
! for Chen x=[110], y=[-11-2],z=[-111]
real, parameter :: a=1.0    !a=1.4142      !1.4142   
real, parameter :: b=1.0    !2.4495     !1.7321 
real, parameter :: c=1.0    !1.7321     !2.4495
open(1,file='cell.fcc')
open(12,file="ckeck1_fcc")
!base(1,1)=0.
!base(1,2)=-1./sqrt(2.)
!base(1,3)=1./sqrt(2.)
!base(2,1)=1./sqrt(3.)
!base(2,2)=-1./sqrt(3.)
!base(2,3)=-1./sqrt(3.)
!base(3,1)=2./sqrt(6.)
!base(3,2)=1./sqrt(6.)
!base(3,3)=1./sqrt(6.)
!R=sqrt(11.)
! FOR x=[111], y=[11 -2], z=[-1 1 0]
!base(1,1)=1./sqrt(3.)
!base(1,2)=1./sqrt(3.)
!base(1,3)=1./sqrt(3.)
!base(2,1)=1./sqrt(6.)
!base(2,2)=1./sqrt(6.)
!base(2,3)=-2./sqrt(6.)
!base(3,1)=-1./sqrt(2.)
!base(3,2)=1./sqrt(2.)
!base(3,3)=0. 
!R=sqrt(11.)
! For Chen: x=[110], y=[-11-2], z=[-111]: 1st notation of axis; second is component
!base(1,1)=1./sqrt(2.)
!base(1,2)=1./sqrt(2.)
!base(1,3)=0. 
!base(2,1)=-1./sqrt(6.)
!base(2,2)=1./sqrt(6.)
!base(2,3)=-2./sqrt(6.)
!base(3,1)=-1./sqrt(3.)
!base(3,2)=1./sqrt(3.)
!base(3,3)=1./sqrt(3.)
!R=sqrt(11.)
base(1,1)=1.0
base(1,2)=0.0
base(1,3)=0.0
base(2,1)=0.0
base(2,2)=1.0
base(2,3)=0.0
base(3,1)=0.0
base(3,2)=0.0
base(3,3)=1.0
R=3
depth=int(R)+1
n=0
do k=-depth,depth
  do i=-depth,depth
	do j=-depth,depth
			x=float(i)+0.0
			y=float(j)+0.0
			z=float(k)+0.0
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c                                                             
!			typ=2
            typ=6
!	write(12,*) "base(1,1), base(1,2),base(1,3), x,y,z, x0",base(1,1), base(1,2),base(1,3), x,y,z, x0 
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
!	write(12,*) "8 corner points, x0,y0,z0,typ",x0,y0,z0,typ 
!F          Following originally is for body center
!F			x=float(i)+0.5d0
!F			y=float(j)+0.5d0
!F			z=float(k)+0.5d0
!F			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c                                                             
!F			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c                                                             
!F			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c                                                             
!F			typ=1
!F			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
!F  for adding face center atom XOY-plane
			x=float(i)+0.5d0
			y=float(j)+0.5d0
			z=float(k)+0.0d0
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c                                                             
!			typ=2
            typ=6
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
!			write(12,*) "Center of XOY_plane,x0,y0,z0,typ",x0,y0,z0,typ 
!F  for adding face center atom XOZ-plane
			x=float(i)+0.5d0
			y=float(j)+0.0d0
			z=float(k)+0.5d0
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c                                                             
!			typ=2
            typ=6
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
!			write(12,*) "Center of XOZ plane, x0,y0,z0,typ",x0,y0,z0,typ 
!F   for adding face center atom YOZ-plane
			x=float(i)+0.0d0
			y=float(j)+0.5d0
			z=float(k)+0.5d0
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c                                                             
!			typ=2
            typ=6
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
!			write(12,*) "Center of YOZ plane,x0,y0,z0,typ",x0,y0,z0,typ 
		enddo
	enddo
enddo
close(1)
print *,n
end subroutine CellFcc						! Tool to check how many atoms in primitive cell

subroutine	CellFe4N						! Tool to check how many atoms in primitive cell
real :: base(3,3),R
real :: x0,y0,z0,x,y,z
integer i,j,k,n,depth,typ,l
real, parameter :: a0=3.795   ! iron
!real, parameter :: a0=4.05 
!real, parameter :: a0=3.62     ! Copper
real, parameter :: a=1.0
real, parameter :: b=1.0
real, parameter :: c=1.0
open(1,file='cell.Fe4N')
!base(1,1)=0.
!base(1,2)=-1./sqrt(2.)
!base(1,3)=1./sqrt(2.)
!base(2,1)=1./sqrt(3.)
!base(2,2)=-1./sqrt(3.)
!base(2,3)=-1./sqrt(3.)
!base(3,1)=2./sqrt(6.)
!base(3,2)=1./sqrt(6.)
!base(3,3)=1./sqrt(6.)
!R=sqrt(11.)
!depth=int(R)+1
!n=0
base(1,1)=1.0
base(1,2)=0.0
base(1,3)=0.0
base(2,1)=0.0
base(2,2)=1.0
base(2,3)=0.0
base(3,1)=0.0
base(3,2)=0.0
base(3,3)=1.0
R=3
depth=int(R)+1
n=0
do k=-depth,depth
   do i=-depth,depth
	do j=-depth,depth
! for Fe, i=1
			x=float(i)+0.0d0
			y=float(j)+0.0d0
			z=float(k)+0.0d0
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z                                                             
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z                                                             
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z                                                             
			typ=1
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for Fe, i=2
			x=float(i)+0.0d0
			y=float(j)+0.5d0
			z=float(k)+0.5d0
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z                                                             
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z                                                             
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z                                                             
			typ=1
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for Fe, i=3
			x=float(i)+0.5d0
			y=float(j)+0.0d0
			z=float(k)+0.5d0
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z                                                             
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z                                                             
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z                                                             
			typ=1
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for Fe, i=4
			x=float(i)+0.5d0
			y=float(j)+0.5d0
			z=float(k)+0.0d0
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z                                                             
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z                                                             
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z                                                             
			typ=1
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for N   j=1
			x=float(i)+0.5d0
			y=float(j)+0.5d0
			z=float(k)+0.5d0
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z                                                             
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z                                                             
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z                                                             
			typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
		enddo
	enddo
enddo
close(1)
print *,n
end subroutine CellFe4N						! Tool to check how many atoms in primitive cell

subroutine CellRutile                                                   ! Tool
real :: base(3,3),R
real :: x0,y0,z0,x,y,z
integer i,j,k,n,depth,typ
real, parameter :: a0=4.7348   ! iron
real, parameter :: a=1.0
real, parameter :: b=1.0
real, parameter :: c=0.672397989
real, parameter :: u=0.30573
open(1,file='cell.SnO2')
base(1,1)=1.
base(1,2)=0.
base(1,3)=0.
base(2,1)=0.
base(2,2)=1.
base(2,3)=0.
base(3,1)=0.
base(3,2)=0.
base(3,3)=1.
R=sqrt(11.)
depth=int(R)+1
n=0
do i=-depth,depth
do j=-depth,depth
do k=-depth,depth
x=float(i)
y=float(j)
z=float(k)
x0=base(1,1)*x+base(1,2)*y+base(1,3)*z
y0=base(2,1)*x+base(2,2)*y+base(2,3)*z
z0=base(3,1)*x+base(3,2)*y+base(3,3)*z
typ=50
call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
x=float(i)+0.5d0
y=float(j)+0.5d0
z=float(k)+0.5d0
x0=base(1,1)*x+base(1,2)*y+base(1,3)*z
y0=base(2,1)*x+base(2,2)*y+base(2,3)*z
z0=base(3,1)*x+base(3,2)*y+base(3,3)*z
typ=50
call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
x=float(i)+u
y=float(j)+u
z=float(k)+0.0
x0=base(1,1)*x+base(1,2)*y+base(1,3)*z
y0=base(2,1)*x+base(2,2)*y+base(2,3)*z
z0=base(3,1)*x+base(3,2)*y+base(3,3)*z
typ=8
call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
x=float(i)-u
y=float(j)-u
z=float(k)+0.0
x0=base(1,1)*x+base(1,2)*y+base(1,3)*z
y0=base(2,1)*x+base(2,2)*y+base(2,3)*z
z0=base(3,1)*x+base(3,2)*y+base(3,3)*z
typ=8
call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
x=float(i)+0.5d0+u
y=float(j)+0.5d0-u
z=float(k)+0.5d0
x0=base(1,1)*x+base(1,2)*y+base(1,3)*z
y0=base(2,1)*x+base(2,2)*y+base(2,3)*z
z0=base(3,1)*x+base(3,2)*y+base(3,3)*z
typ=8
call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
x=float(i)+0.5d0-u
y=float(j)+0.5d0+u
z=float(k)+0.5d0
x0=base(1,1)*x+base(1,2)*y+base(1,3)*z
y0=base(2,1)*x+base(2,2)*y+base(2,3)*z
z0=base(3,1)*x+base(3,2)*y+base(3,3)*z
typ=8
call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
enddo
enddo
enddo
close(1)
print *,n
end subroutine CellRutile


subroutine	CellLi3PO4						! Tool to check how many atoms in primitive cell
real :: base(3,3),R
real :: x0,y0,z0,x,y,z
integer i,j,k,n,depth,typ,l
real, parameter :: a0=6.12   ! iron
!real, parameter :: a0=4.05 
!real, parameter :: a0=3.62     ! Copper
real, parameter :: a=1.0
real, parameter :: b=0.8562
real, parameter :: c=0.7941
open(1,file='cell.Li3PO4')
!base(1,1)=0.
!base(1,2)=-1./sqrt(2.)
!base(1,3)=1./sqrt(2.)
!base(2,1)=1./sqrt(3.)
!base(2,2)=-1./sqrt(3.)
!base(2,3)=-1./sqrt(3.)
!base(3,1)=2./sqrt(6.)
!base(3,2)=1./sqrt(6.)
!base(3,3)=1./sqrt(6.)
!R=sqrt(11.)
!depth=int(R)+1
!n=0
base(1,1)=1.0
base(1,2)=0.0
base(1,3)=0.0
base(2,1)=0.0
base(2,2)=1.0
base(2,3)=0.0
base(3,1)=0.0
base(3,2)=0.0
base(3,3)=1.0
R=6
depth=int(R)+1
n=0
do i=-depth,depth
	do j=-depth,depth
            do k=-depth,depth
! for Li, i=1
			x=float(i)+0.248d0
			y=float(j)+0.328d0
			z=float(k)+0.986d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=3
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for Li, i=2
			x=float(i)+0.752d0
			y=float(j)+0.328d0
			z=float(k)+0.986d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=3
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for Li, i=3
			x=float(i)+0.252d0
			y=float(j)+0.672d0
			z=float(k)+0.486d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=3
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for Li, i=4
			x=float(i)+0.748d0
			y=float(j)+0.672d0
			z=float(k)+0.486d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=3
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for Li   i=5
			x=float(i)+0.00d0
			y=float(j)+0.157d0
			z=float(k)+0.489d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=3
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for Li, i=6
			x=float(i)+0.5d0
			y=float(j)+0.843d0
			z=float(k)+0.989d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=3
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for P, i=1
			x=float(i)-0.00d0
			y=float(j)+0.824d0
			z=float(k)+0.00d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=15
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for P, i=2
			x=float(i)+0.5d0
			y=float(j)+0.176d0
			z=float(k)+0.5d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=15
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for O, i=1
			x=float(i)+0.208d0
			y=float(j)+0.687d0
			z=float(k)+0.896d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=8
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for O   i=2
			x=float(i)+0.792d0
			y=float(j)+0.687d0
			z=float(k)+0.896d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=8
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! fro O, i=3
                        x=float(i)+0.292d0
			y=float(j)+0.313d0
			z=float(k)+0.396d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=8
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for O, i=4
			x=float(i)+0.708d0
			y=float(j)+0.313d0
			z=float(k)+0.396d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=8
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for O, i=4
			x=float(i)+0.000d0
			y=float(j)+0.105d0
			z=float(k)+0.900d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=8
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for O, i=6
			x=float(i)+0.5d0
			y=float(j)+0.895d0
			z=float(k)+0.4d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=8
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for O   i=7
			x=float(i)+0.00d0
			y=float(j)+0.819d0
			z=float(k)+0.317d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=8
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for O   i=8
			x=float(i)+0.5d0
			y=float(j)+0.181d0
			z=float(k)+0.817d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=8
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
		enddo
	enddo
enddo
close(1)
print *,n
end subroutine CellLi3PO4						! Tool to check how many atoms in primitive cell


subroutine	CellLi2FeSiO4						! Tool to check how many atoms in primitive cell
real :: base(3,3),R
real :: x0,y0,z0,x,y,z
integer i,j,k,n,depth,typ,l
real, parameter :: a0=6.266   ! iron
!real, parameter :: a0=4.05 
!real, parameter :: a0=3.62     ! Copper
real, parameter :: a=1.0
real, parameter :: b=0.8504628
real, parameter :: c=0.8003511
open(1,file='cell.Li2FeSiO4')
!base(1,1)=0.
!base(1,2)=-1./sqrt(2.)
!base(1,3)=1./sqrt(2.)
!base(2,1)=1./sqrt(3.)
!base(2,2)=-1./sqrt(3.)
!base(2,3)=-1./sqrt(3.)
!base(3,1)=2./sqrt(6.)
!base(3,2)=1./sqrt(6.)
!base(3,3)=1./sqrt(6.)
!R=sqrt(11.)
!depth=int(R)+1
!n=0
base(1,1)=1.0
base(1,2)=0.0
base(1,3)=0.0
base(2,1)=0.0
base(2,2)=1.0
base(2,3)=0.0
base(3,1)=0.0
base(3,2)=0.0
base(3,3)=1.0
R=6
depth=int(R)+1
n=0
do i=-depth,depth
	do j=-depth,depth
            do k=-depth,depth
! for Li, i=1
			x=float(i)+0.237d0
			y=float(j)+0.325d0
			z=float(k)+0.842d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=3
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for Li, i=2
			x=float(i)+0.263d0
			y=float(j)+0.675d0
			z=float(k)+0.342d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=3
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for Li, i=3
			x=float(i)+0.763d0
			y=float(j)+0.325d0
			z=float(k)+0.842d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=3
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for Li, i=4
			x=float(i)+0.737d0
			y=float(j)+0.675d0
			z=float(k)+0.342d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=3
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for Fe   i=1
			x=float(i)+0.00d0
			y=float(j)+0.169d0
			z=float(k)+0.423d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=26
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for Fe, i=2
			x=float(i)+0.5d0
			y=float(j)+0.831d0
			z=float(k)+0.923d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=26
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for Si, i=1
			x=float(i)+0.00d0
			y=float(j)+0.841d0
			z=float(k)+0.00d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=14
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for Si, i=2
			x=float(i)+0.5d0
			y=float(j)+0.159d0
			z=float(k)+0.5d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=14
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for O, i=1
			x=float(i)+0.217d0
			y=float(j)+0.687d0
			z=float(k)+0.884d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=8
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for O   i=2
			x=float(i)+0.283d0
			y=float(j)+0.313d0
			z=float(k)+0.384d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=8
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! fro O, i=3
                        x=float(i)+0.000d0
			y=float(j)+0.833d0
			z=float(k)+0.360d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=8
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for O, i=4
			x=float(i)+0.500d0
			y=float(j)+0.863d0
			z=float(k)+0.350d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=8
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for O, i=4
			x=float(i)+0.500d0
			y=float(j)+0.167d0
			z=float(k)+0.860d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=8
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for O, i=6
			x=float(i)+0.7830d0
			y=float(j)+0.6870d0
			z=float(k)+0.8840d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=8
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for O   i=7
			x=float(i)+0.7170d0
			y=float(j)+0.3130d0
			z=float(k)+0.3840d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=8
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! for O   i=8
			x=float(i)+0.0000d0
			y=float(j)+0.1370d0
			z=float(k)+0.8500d0
			x0=base(1,1)*x+base(1,2)*y*b+base(1,3)*z*c                                                             
			y0=base(2,1)*x+base(2,2)*y*b+base(2,3)*z*c                                                             
			z0=base(3,1)*x+base(3,2)*y*b+base(3,3)*z*c                                                             
			typ=8
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
		enddo
	enddo
enddo
close(1)
print *,n
end subroutine CellLi2FeSiO4						! Tool to check how many atoms in primitive cell


subroutine CellZno							! Tool to check how many atoms in primitive cell
real :: base(3,4),R
! new axis are x0,y0,z0; lattice axis are x,y,z,w (in Hcp lattice, 4 is necessary)
real :: x0,y0,z0,x,y,z,w
integer i,j,k,n,depth,typ, l
real, parameter ::a0=3.2489     !3.2489    ! Al2O3
real, parameter :: a=1.0      !1.4142   
real, parameter :: b=0.8660254     !1.7321 
real, parameter :: c=1.60205    !2.4495
open(1,file='cell.zno')
open(12,file="ckeck1_zno")
! For HcP: for Si3N4 Here 1st notation, Model axis, as X, Y, Z cartisian axis; second is lattice axis, a, b, c
! Si3N4:  a=b=7.765, c=5.622, alpha=beta=90, gma=120
base(1,1)=1.0
base(1,2)=-0.5
base(1,3)=0. 
base(2,1)=0
base(2,2)=0.8660254038
base(2,3)=0. 
base(3,1)=0
base(3,2)=0.
base(3,3)=1.0
R=sqrt(11.)
depth=int(R)+1
n=0
!print *,"a"

do k=-depth,depth
   do i=-depth,depth
	do j=-depth,depth
! For Zn (type=1) 2c  l=1
			x=0.33333+float(i)
			y=0.66667+float(j)
			z=0.3815+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
           typ=1       

			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
!			print *,"c1, n=", n

! For Zn (type=1) 2c  l=2
			x=0.66667+float(i)
			y=0.33333+float(j)
			z=0.8815+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
          typ=1
!print *,"b"
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For O (type=1) 2b  l=3
			x=0.33333+float(i)
			y=0.66667+float(j)
			z=0.00000+float(k)      ! wrong: z=0.3815+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2                      
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
!			print *,"c3, n=", n

! For O (type=1) 2b  l=4
			x=0.66667+float(i)
			y=0.33333+float(j)
			z=0.50000+float(k)     !wrong: z=0.3815+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
     	enddo
	enddo
enddo
print *,"d, n=", n
close(1)
print *,n
end subroutine CellZno						! Tool to check how many atoms in primitive cell


subroutine CellAl2O3							! Tool to check how many atoms in primitive cell
real :: base(3,4),R
! new axis are x0,y0,z0; lattice axis are x,y,z,w (in Hcp lattice, 4 is necessary)
real :: x0,y0,z0,x,y,z,w
integer i,j,k,n,depth,typ, l
real, parameter :: a0=4.7607    ! Al2O3
real, parameter :: a=1.0  ! 0.5      !1.4142   
real, parameter :: b=0.8660254     !1.7321 
real, parameter :: c=2.72958    !2.4495
open(1,file='cell.Al2O3')
open(12,file="ckeck1_Al2O3")
! For HcP: for Si3N4 Here 1st notation, Model axis, as X, Y, Z cartisian axis; second is lattice axis, a, b, c
! Si3N4:  a=b=7.765, c=5.622, alpha=beta=90, gma=120
base(1,1)=1.0
base(1,2)=-0.5
base(1,3)=0. 
base(2,1)=0
base(2,2)=0.8660254038
base(2,3)=0. 
base(3,1)=0
base(3,2)=0.
base(3,3)=1.0
R=sqrt(11.)
depth=int(R)+1
n=0
do k=-depth,depth
   do i=-depth,depth
	do j=-depth,depth
! For Al (type=1) 12c  l=1
			x=0+float(i)
			y=0+float(j)
			z=0.35216+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=4       
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Al (type=1) 12c  l=2
			x=0+float(i)
			y=0+float(j)
			z=-0.35216+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=4
            call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Al (type=1) 12c  l=3
			x=0+float(i)
			y=0+float(j)
			z=0.85216+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=4
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Al (type=1) 12c  l=4
			x=0+float(i)
			y=0+float(j)
			z=0.14784+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=4
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Al (type=1) 12c  l=5
			x=0.33334+float(i)
			y=0.66667+float(j)
			z=1.018827+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=4
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Al (type=1) 12c  l=6
			x=0.33334+float(i)
			y=0.66667+float(j)
			z=0.314507+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=4
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Al (type=1) 12c  l=7
			x=0.33334+float(i)
			y=0.66667+float(j)
			z=1.51883+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=4
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Al (type=1) 12c  l=8
			x=0.33334+float(i)
			y=0.66667+float(j)
			z=0.814507+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=4
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Al (type=1) 12c  l=9
	        x=0.66667+float(i)
			y=0.33334+float(j)
			z=0.685493+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=4
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Al (type=1) 12c  l=10
			x=0.66667+float(i)
			y=0.33334+float(j)
			z=-0.018827+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=4
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Al (type=1) 12c  l=11
			x=0.66667+float(i)
			y=0.33334+float(j)
			z=1.185493+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=4
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Al (type=1) 12c  l=12
			x=0.66667+float(i)
			y=0.33334+float(j)
			z=0.481173+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=4
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For O (type=2) 18e  m=1
			x=0.3061+float(i)
			y=0+float(j)
			z=0.25+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For O (type=2) 18e  m=2
			x=0+float(i)
			y=0.3061+float(j)
			z=0.25+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For O (type=2) 18e  m=3
			x=-0.3061+float(i)
			y=-0.3061+float(j)
			z=0.25+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For O (type=2) 18e  m=4
			x=-0.3061+float(i)
			y=0+float(j)             !	y=-0.61242+float(j)
			z=0.75+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For O (type=2) 18e  m=5
			x=0+float(i)
			y=-0.3061+float(j)
			z=0.75+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For O (type=2) 18e  m=6
			x=0.3061+float(i)
			y=0.3061+float(j)
			z=0.75+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For O (type=2) 18e  m=7
			x=0.63943+float(i)
			y=0.66667+float(j)
			z=0.91667+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For O (type=2) 18e  m=8
			x=0.33334+float(i)
			y=0.97277+float(j)
			z=0.91667+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For O (type=2) 18e  m=9
			x=0.02723+float(i)
			y=0.36057+float(j)
			z=0.91667+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For O (type=2) 18e  m=10
			x=0.02733+float(i)
			y=0.66667+float(j)
			z=1.41667+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For O (type=2) 18e  m=11
			x=0.33334+float(i)
			y=0.36057+float(j)
			z=1.41667+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For O (type=2) 18e  m=12
			x=0.63943+float(i)
			y=0.97277+float(j)
			z=1.41667+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For O (type=2) 18e  m=13
			x=0.97277+float(i)
			y=0.33334+float(j)
			z=0.58333+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For O (type=2) 18e  m=14
			x=0.66667+float(i)
			y=0.63943+float(j)
			z=0.58333+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)		
! For O (type=2) 18e  m=15
			x=0.36057+float(i)
			y=0.02723+float(j)
			z=0.58333+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For O (type=2) 18e  m=16
			x=0.36057+float(i)
			y=0.33334+float(j)
			z=1.08333+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For 0 (type=2) 18e m=17
            x=0.66667+float(i)
            y=0.02723+float(j)
            z=1.08333+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
            call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For 0 (type=2) 18e m=18
            x=0.97277+float(i)
            y=0.63943+float(j)
            z=1.08333+float(k)
            x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
            y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
            z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
        	typ=2
            call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
        enddo
	enddo
enddo
close(1)
print *,n
end subroutine CellAl2O3						! Tool to check how many atoms in primitive cell


subroutine CellSi3N4							! Tool to check how many atoms in primitive cell
real :: base(3,4),R
! new axis are x0,y0,z0; lattice axis are x,y,z,w (in Hcp lattice, 4 is necessary)
real :: x0,y0,z0,x,y,z,w
integer i,j,k,n,depth,typ, l
real, parameter :: a0=7.732    ! 7.765 Si3N4
real, parameter :: a=1.0      !1.4142   
real, parameter :: b=0.871562     !1.7321 
real, parameter :: c=0.737067        !0.724018     !2.4495
open(1,file='cell.Si3N4')
open(12,file="ckeck1_Si3N4")
! For HcP: for Si3N4 Here 1st notation, Model axis, as X, Y, Z cartisian axis; second is lattice axis, a, b, c
! Si3N4:  a=b=7.765, c=5.622, alpha=beta=90, gma=120
base(1,1)=1.0
base(1,2)=-0.5
base(1,3)=0. 
base(2,1)=0
base(2,2)=0.8660254038
base(2,3)=0. 
base(3,1)=0
base(3,2)=0.
base(3,3)=1.0
R=sqrt(11.)
depth=int(R)+1
n=0
do k=-depth,depth
   do i=-depth,depth
	do j=-depth,depth
! For Si (type=1) 6c  l=1
			x=0.51306+float(i)
			y=0.43056+float(j)
			z=0.6589+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=1       
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Si (type=1) 6c  l=2
			x=-0.43056+float(i)
			y=0.0825+float(j)
			z=0.6589+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=1
            call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Si (type=1) 6c  l=3
			x=-0.0825+float(i)
			y=-0.51306+float(j)
			z=0.6589+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=1
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Si (type=1) 6c  l=4
			x=0.43056+float(i)
			y=0.51306+float(j)
			z=1.1589+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=1
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Si (type=1) 6c  l=5
			x=-0.51306+float(i)
			y=-0.0825+float(j)
			z=1.1589+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=1
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Si (type=1) 6c  l=6
			x=0.0825+float(i)
			y=-0.43056+float(j)
			z=1.1589+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=1
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Si (type=1) 6c  l=7
			x=0.16807+float(i)
			y=0.91506+float(j)
			z=0.45049+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=1
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Si (type=1) 6c  l=8
			x=-0.91506+float(i)
			y=-0.74699+float(j)
			z=0.45049+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=1
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Si (type=1) 6c  l=9
			x=0.74699+float(i)
			y=-0.16807+float(j)
			z=0.45049+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=1
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Si (type=1) 6c  l=10
			x=0.91506+float(i)
			y=0.16807+float(j)
			z=0.95049+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=1
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Si (type=1) 6c  l=11
			x=-0.16807+float(i)
			y=0.74699+float(j)
			z=0.95049+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=1
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For Si (type=1) 6c  l=12
			x=-0.74699+float(i)
			y=-0.91506+float(j)
			z=0.95049+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=1
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For N (type=2) 6c  m=1
			x=0.61242+float(i)
			y=0.95922+float(j)
			z=0.434326+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For N (type=2) 6c  m=2
			x=-0.95922+float(i)
			y=-0.3468+float(j)
			z=0.434326+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For N (type=2) 6c  m=3
			x=0.3468+float(i)
			y=-0.61242+float(j)
			z=0.434326+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For N (type=2) 6c  m=4
			x=0.95922+float(i)
			y=0.61242+float(j)             !	y=-0.61242+float(j)
			z=0.934326+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For N (type=2) 6c  m=5
			x=-0.61242+float(i)
			y=0.3468+float(j)
			z=0.934326+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For N (type=2) 6c  m=6
			x=-0.3468+float(i)
			y=-0.95922+float(j)
			z=0.934326+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For N (type=2) 6c  m=7
			x=0.319918+float(i)
			y=0.004620+float(j)
			z=0.704532+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For N (type=2) 6c  m=8
			x=-0.004620+float(i)
			y=0.315298+float(j)
			z=0.704532+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For N (type=2) 6c  m=9
			x=-0.315298+float(i)
			y=-0.319918+float(j)
			z=0.704532+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For N (type=2) 6c  m=10
			x=0.004620+float(i)
			y=0.319918+float(j)
			z=1.204532+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For N (type=2) 6c  m=11
			x=-0.319918+float(i)
			y=-0.315298+float(j)
			z=1.204532+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For N (type=2) 6c  m=12
			x=0.315298+float(i)
			y=-0.004620+float(j)
			z=1.204532+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For N (type=2) 6c  m=13
			x=0.3333+float(i)
			y=0.6666+float(j)
			z=0.601536+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For N (type=2) 6c  m=14
			x=0.6666+float(i)
			y=0.3333+float(j)
			z=1.101536+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For N (type=2) 6c  m=15
			x=0.0+float(i)
			y=0.0+float(j)
			z=0.452045+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
! For N (type=2) 6c  m=16
			x=0.0+float(i)
			y=0.0+float(j)
			z=0.952045+float(k)
			x0=base(1,1)*x+base(1,2)*y+base(1,3)*z*c
			y0=base(2,1)*x+base(2,2)*y+base(2,3)*z*c
			z0=base(3,1)*x+base(3,2)*y+base(3,3)*z*c
            typ=2
			call judge(x0*a0,y0*a0,z0*a0,n,a*a0,b*a0,c*a0,typ)
     	enddo
	enddo
enddo
close(1)
print *,n
end subroutine CellSi3N4						! Tool to check how many atoms in primitive cell

subroutine judge(x0,y0,z0,cnt,a,b,c,typ)
real :: x0,y0,z0,a,b,c
integer cnt,typ
logical InX,InY,InZ
real, parameter :: eps=1.e-3  !1.e-2   !1.e-3
!open(12,Check1_fcc)
InX=x0>=0.d0-eps .and. x0<a-eps
InY=y0>=0.d0-eps .and. y0<b-eps
InZ=z0>=0.d0-eps .and. z0<c-eps
if(InX .and. InY .and. InZ) then
	write(1,'(3f24.15,i6)') x0/a,y0/b,z0/c,typ		! Save as unitless or normalized coordinates
	cnt=cnt+1
!	print *, x0/a,y0/b,z0/c,typ,cnt
!	if(phase.eq.'Y') then
!	write(11,*) "$, x0,y0,z0,x0/a,y0/b,z0/c,typ", x0,y0,z0,x0/a,y0/b,z0/c,typ
!	endif
endif
end subroutine judge

subroutine Beam(phase,scale)
	use control
	character phase
	integer scale
!   real, parameter :: a0=3.62    !Copper    
!   real, parameter :: a0=4.05    !Aluminion
	real, parameter :: a0=2.92    !Iron
	real, parameter :: af=1.0*a0  ! for iron   
	real, parameter :: bf=1.0*a0    
	real, parameter :: cf=1.0*a0   
	real, parameter :: ay=4.0559  !3.629   ! for Al (copper)   
	real, parameter :: by=4.0559  !3.629      
	real, parameter :: cy=4.0559  !3.629   
  	real, parameter :: az=3.2489  ! for ZnO    
	real, parameter :: bz=2.8163      
	real, parameter :: cz=5.2049 
	real, parameter :: an=3.795   ! for Fe4N 
	real, parameter :: bn=3.795   
	real, parameter :: cn=3.795 
	real, parameter :: ao=6.12   ! for Li3PO4 
	real, parameter :: bo=5.24   
	real, parameter :: co=4.86 
	real, parameter :: am=6.266   ! for Li2FeSiO4 
	real, parameter :: bm=5.329   
	real, parameter :: cm=5.015 
	real, parameter :: al=4.7607  ! for Al2O3      
	real, parameter :: bl=4.12289      
	real, parameter :: cl=12.9947
	real, parameter :: ap=7.732    !7.765      
	real, parameter :: bp=6.73892  !6.724   ! for Si3N4     
	real, parameter :: cp=5.699    !5.622  
        real, parameter :: ar=4.7348
        real, parameter :: br=4.7348
        real, parameter :: cr=3.18367 !SnO2
	real, parameter :: eps=1.e-3
	real :: a,b,c
	real :: x,y,z
	integer i,j,k,l,ncell
	integer XSize,YSize,ZSize
	logical InBlockX,InBlockY,InBlockZ,InBlock
	integer, dimension (50)::jlog
	real, allocatable, dimension(:,:) ::cell
	open(11,file='Check.fcc')
!	open(12,file='check.Apatite')
	open(13,file='check.Silicon')
	open(14,file='check.Apatite')
!	print *,"phase1", phase
	select case (phase)
	case ('B')	! Ferrite in plain orientation
		a=a0*2.0**(scale-1)
		b=a0*2.0**(scale-1)
		c=a0*2.0**(scale-1)
		print *,"a,b,c", a,b,c
		FName='BasicCell.bcc'
		ncell=2
	case ('F')	
	    ! For Ferrite, because its lattice constant is 2.87 but we use copper 10=3.62 as basic a0
		a=af*2.0**(scale-1)
                b=bf*2.0**(scale-1)
		c=cf*2.0**(scale-1)
		print *,"a,b,c", a,b,c
		FName='cell.bcc'
		ncell=2
	case ('Y')	! Copper
	    a=ay*2.0**(scale-1)      !F 3.62A and 2.87A are respectively lattice constant of Cu and iron
		b=by*2.0**(scale-1)      !Here, we take iron as the basis, if take copper and Nickel then
		c=cy*2.0**(scale-1) 
    	print *,"a,b,c", a,b,c 
		FName='cell.fcc'
		ncell=4
	case ('Z')	! Hcp for Si3N4
	    a=az*2.0**(scale-1)      !F 3.62A and 2.87A are respectively lattice constant of Cu and iron
		b=bz*2.0**(scale-1)      !Here, we take iron as the basis, if take copper and Nickel then
		c=cz*2.0**(scale-1) 
     	print *,"a,b,c", a,b,c 
		FName='cell.zno'
		ncell=4  
	case ('N')	! 
		a=an*2.0**(scale-1)
		b=bn*2.0**(scale-1)
		c=cn*2.0**(scale-1)
		print *,"a,b,c", a,b,c
		FName='cell.Fe4N'
		ncell=5   
	case ('O')	! 
		a=ao*2.0**(scale-1)
		b=bo*2.0**(scale-1)
		c=co*2.0**(scale-1)
		print *,"a,b,c", a,b,c
		FName='cell.Li3PO4'
		ncell=16  
        case ('R')      ! Hcp for SnO2
         a=ar*2.0**(scale-1)      !F 3.62A and 2.87A are respectively lattice constant of Cu and iron
         b=br*2.0**(scale-1)      !Here, we take iron as the basis, if take copper and Nickel then
         c=cr*2.0**(scale-1) 
       print *,"a,b,c", a,b,c 
              FName='cell.SnO2'
              ncell=6     !24    !4    !24
	case ('M')	! 
		a=am*2.0**(scale-1)
		b=bm*2.0**(scale-1)
		c=cm*2.0**(scale-1)
		print *,"a,b,c", a,b,c
		FName='cell.Li2FeSiO4'
		ncell=16   
	case ('L')	! Hcp for Si3N4
	    a=al*2.0**(scale-1)      !F 3.62A and 2.87A are respectively lattice constant of Cu and iron
		b=bl*2.0**(scale-1)      !Here, we take iron as the basis, if take copper and Nickel then
		c=cl*2.0**(scale-1) 
     	print *,"a,b,c", a,b,c 
		FName='cell.Al2O3'
		ncell=30 
	case ('P')	! Hcp for Si3N4
	    a=ap*2.0**(scale-1)      !F 3.62A and 2.87A are respectively lattice constant of Cu and iron
		b=bp*2.0**(scale-1)      !Here, we take iron as the basis, if take copper and Nickel then
		c=cp*2.0**(scale-1) 
     	print *,"a,b,c", a,b,c 
		FName='cell.Si3N4'
		ncell=28     !24    !4    !24
	end select
	XSize=int(ModelSize(1)/a)+1
	YSize=int(ModelSize(2)/b)+1
	ZSize=int(ModelSize(3)/c)+1
	allocate(cell(3,ncell))
	open(10,file=FName)
!	write(11,*) "a,b,c,XSize,YSize,ZSize", a,b,c,XSize,YSize,ZSize
!   Write different coordinates in the Cell; for instance in fcc it will write 24 there. 
	do i=1,ncell
		read(10,*) cell(1,i),cell(2,i),cell(3,i),j
		print *, cell(1,i),cell(2,i),cell(3,i),j
	If(phase.eq.'Y')write(11,*) "i, cell(1,i),cell(2,i),cell(3,i),j",i, cell(1,i),cell(2,i),cell(3,i),j
	If(phase.eq.'P')write(12,*) "i, cell(1,i),cell(2,i),cell(3,i),j",i, cell(1,i),cell(2,i),cell(3,i),j
	If(phase.eq.'G')write(13,*) "i, cell(1,i),cell(2,i),cell(3,i),j",i, cell(1,i),cell(2,i),cell(3,i),j
	If(phase.eq.'A')write(14,*) "i, cell(1,i),cell(2,i),cell(3,i),j",i, cell(1,i),cell(2,i),cell(3,i),j
	jlog(i)=j
	print *, j
	enddo
	close(10)
	WRITE(FName,'(a3,i2,a3)') phase,scale,'.bm'
	open(20,file=FName)
   do k=-ZSize,ZSize
	do i=-XSize,XSize
		do j=-YSize,YSize
				do l=1,ncell
					x=( float(i)+cell(1,l) )*a
					y=( float(j)+cell(2,l) )*b
					z=( float(k)+cell(3,l) )*c
					InBlockX=x.ge.-ModelSize(1)-eps .and. x.lt.ModelSize(1)-eps
					InBlockY=y.ge.-ModelSize(2)-eps .and. y.lt.ModelSize(2)-eps
					InBlockZ=z.ge.-ModelSize(3)-eps .and. z.lt.ModelSize(3)-eps
					InBlock=InBlockX .and. InBlockY .and. InBlockZ
					if(InBlock) then
!						  If(phase.eq.'E')then
!						  write(20,*)x,y,z,scale,9
!						  endif  
                        write(20,*)x,y,z,scale,jlog(l)
!						print *,jlog(l)
						NAtoms=NAtoms+1									! count the atoms in tmp.dat
					endif
				enddo
			enddo
		enddo
	enddo
	close(20)
	close(11)
	close(12)
end subroutine Beam
	
	
subroutine Input	! Generate the composite model and cut it into required shape
	use control
	integer Blocks,scale,ncut
	character phase,cuttype
	real left,right,back,front,lower,upper
	real xc,yc,zc,rc,ro,ri
	real leftc,rightc,backc,frontc,lowerc,upperc
	logical InX,InY,InZ,InCut
	integer i,j
	real x,y,z,dist
	integer scaleabs,atomtype
	real, parameter :: eps=1.e-3
	FOut='Model.MD'
	open(100,file=FOut)
	open(1,file='model.in')
!	How many scales are there in your model
!    read(1,'(a80)')fip
    read(1,'(a80)')ftitle
!	read(1,*)levfg,imcon, ntotal, deltat
    print *,"*1"
    read(1,*)levfg,imcon
	print *,"*2"
!	stop  !Fan
	read(1,*)cell1(1),cell1(2),cell1(3)
	read(1,*)cell1(4),cell1(5),cell1(6)
	read(1,*)cell1(7),cell1(8),cell1(9)
	read(1,*) scales
!	Input the size of Cube:
	read(1,*) ModelSize
!	Input the loadsteps to be carried out
!	read(1,*) LoadSteps
!	write seperate files for each scale as the original material to be cut
!	call Beam('C',1)
	do i=1,scales
!	call Beam('B',i)
		call Beam('F',i)
		call Beam('Y',i)
		call Beam('N',i)
		call Beam('Z',i)
		call Beam('L',i)
		call Beam('P',i)  !Li3PO4
		call Beam('M',i)  !Li2FeSiO4
                call Beam('O',i)
                call Beam('R',i) !SnO2
	enddo
!	How many blocks do you need?:(different scale of same crystal should be treated as different layer)
	read(1,*) Blocks
	NAtoms=0
	do i=1,Blocks
		print *, 'Block ',i,' is being generated...'
		read(1,*) phase,scale,ncut
		print *, "phase,scale,ncut",phase, scale,ncut
!    if(phase.eq.'w') go to 111
		read(1,*) left,right,back,front,lower,upper	! Define the outer frame
		! cut for first time
		WRITE(FName,'(a3,i2,a3)') phase,abs(scale),'.bm'
		WRITE(FCut0,'(a3,i2,a4)') phase,scale,'.ct0'
		open(2,file=FName)
		open(3,file=FCut0)
		do while(.true.)
			read(2,*,end=90) x,y,z,scaleabs,atomtype
			InX=x>=left-eps .and. x<=right+eps
			InY=y>=back-eps .and. y<=front+eps
			InZ=z>=lower-eps .and. z<=upper+eps
			InCut=InX .and. InY .and. InZ
			if(scaleabs .ne. abs(scale)) print *,'file reading error in scale'
			if(InCut) write(3,*) x,y,z,scale,atomtype
		enddo
90		close(2)
		close(3)
		do j=1,ncut
			read(1,*) cuttype
			if(cuttype=='c') then
				read(1,*) xc,zc,rc
				WRITE(FCut0,'(a3,i2,a3,i1)') phase,scale,'.ct',j-1
				WRITE(FCut,'(a3,i2,a3,i1)') phase,scale,'.ct',j
				open(2,file=FCut0)
				open(3,file=FCut)
				do while(.true.)
					read(2,*,end=91) x,y,z,scaleabs,atomtype
					dist=sqrt((x-xc)**2+(z-zc)**2)
					InCut=dist .le. rc
					if(.not. InCut) then
						write(3,*) x,y,z,scale,atomtype
						if(j .eq. ncut) then
							NAtoms=NAtoms+1
							write(100,*) x,y,z,scale,atomtype
						endif
					endif
				enddo
91				close(2)
				close(3)
			endif
			if(cuttype=='P') then  !For pores
				read(1,*) xc,yc,zc,rc
				WRITE(FCut0,'(a3,i2,a3,i1)') phase,scale,'.ct',j-1
				WRITE(FCut,'(a3,i2,a3,i1)') phase,scale,'.ct',j
				open(2,file=FCut0)
				open(3,file=FCut)
				do while(.true.)
					read(2,*,end=93) x,y,z,scaleabs,atomtype
					dist=sqrt((x-xc)**2+(y-yc)**2+(z-zc)**2)
					InCut=dist .le. rc
					if(.not. InCut) then
						write(3,*) x,y,z,scale,atomtype
						if(j .eq. ncut) then
							NAtoms=NAtoms+1
							write(100,*) x,y,z,scale,atomtype
						endif
					endif
				enddo
93				close(2)
				close(3)
			endif
			if(cuttype=='T') then  !For Tube
				read(1,*) xc,zc,ro,ri
				WRITE(FCut0,'(a3,i2,a3,i1)') phase,scale,'.ct',j-1
				WRITE(FCut,'(a3,i2,a3,i1)') phase,scale,'.ct',j
				open(2,file=FCut0)
				open(3,file=FCut)
				do while(.true.)
					read(2,*,end=94) x,y,z,scaleabs,atomtype
					dist=sqrt((x-xc)**2+(z-zc)**2)
					InCut=dist .le. ri .or. dist .gt. ro
					if(.not. InCut) then
						write(3,*) x,y,z,scale,atomtype
						if(j .eq. ncut) then
							NAtoms=NAtoms+1
							write(100,*) x,y,z,scale,atomtype
						endif
					endif
				enddo
94				close(2)
				close(3)
			endif
			if(cuttype=='s') then
				read(1,*) leftc,rightc,backc,frontc,lowerc,upperc
				WRITE(FCut0,'(a3,i2,a3,i1)') phase,scale,'.ct',j-1
				WRITE(FCut,'(a3,i2,a3,i1)') phase,scale,'.ct',j
				open(2,file=FCut0)
				open(3,file=FCut)
				do while(.true.)
					read(2,*,end=92) x,y,z,scaleabs,atomtype
					InX=x>=leftc-eps .and. x<=rightc+eps
					InY=y>=backc-eps .and. y<=frontc+eps
					InZ=z>=lowerc-eps .and. z<=upperc+eps
					InCut=InX .and. InY .and. InZ
					if(.not. InCut) then
						write(3,*) x,y,z,scale,atomtype
						if(j .eq. ncut) then
							NAtoms=NAtoms+1
							write(100,*) x,y,z,scale,atomtype
						endif
					endif
				enddo
92				close(2)
				close(3)
			endif
		enddo
111		print *,phase,scale,ncut
enddo
!	close(1)
	close(100)
	print *, NAtoms, ' atoms were generated!'
end subroutine Input

subroutine PrepMem
	use control
	BasePoint=-2.*ModelSize
	ModelSize=4.*ModelSize
	GridSize=4.0
	MCell=int(ModelSize/GridSize)+1
!
!	Prepare the memory
!
	allocate(pos(3,NAtoms))
	allocate(ScaleIndex(NAtoms))
	allocate(AtomTypeIndex(NAtoms))
!	allocate(Isolution(10000))
	allocate(Ivacancy(10000))
	allocate(HEAD(MCell(1)*MCell(2)*MCell(3)))
	allocate(List(NAtoms))
	MaxListLength=NAtoms*MaxPairsPerAtom		! waste memory but no problem
	allocate(NeighborList(MaxListLength))
	allocate(Marker1(NAtoms))
	allocate(Marker2(NAtoms))
end subroutine PrepMem

subroutine Neighbor
use control
real,dimension(3) :: Sij
real ::Rsqij,RsqRange
integer :: SearchDepth,L=1,CntIdeal=0
INTEGER I,J,ICELL,IXYZ(3),IX,IY,IZ,Itmp

!
!	Read in intermediate data from file
!
open(3,file=FOut)
do i=1,NAtoms
	read(3,*) pos(1,i),pos(2,i),pos(3,i),ScaleIndex(i),AtomTypeIndex(i)
	if(ScaleIndex(i)<0) CntIdeal=CntIdeal+1		! Count the numebr of ideal atoms/paticles
enddo
close(3)
!
!	Create the cell link search map
!
call UpdateLinkList
!
!	Find the neighbors
!
Marker1=0
Marker2=0
!!F Establish neighbors for every atom and particle (no matter it is realistic or imaginary
J=0
do I=1,NAtoms
!!FH	if(ScaleIndex(I)<0) then
		Marker1(I) = L
		SearchDepth=2**(abs(ScaleIndex(I))-1)
		IXYZ(:)=Int( (pos(:,I)-BasePoint(:))/GridSize )
		do IX=IXYZ(1)-SearchDepth,IXYZ(1)+SearchDepth
			do IY=IXYZ(2)-SearchDepth,IXYZ(2)+SearchDepth
				do IZ=IXYZ(3)-SearchDepth,IXYZ(3)+SearchDepth
					ICELL=1+IX+ IY*MCELL(1)+ IZ*MCELL(1)*MCELL(2)
						J=HEAD(ICELL)				! The number in HEAD is global
!!FH		Print *,"J,HEAD(ICELL)",ICELL, J
					DO WHILE(J .GT. 0)
						if( I.ne.J .and. abs(ScaleIndex(I)+ScaleIndex(J)).eq.1 ) then      !!FH 
							Itmp=min(abs(ScaleIndex(I)),ABS(ScaleIndex(J)))
							RsqRange=GridSize*2.0**(Itmp-1)
							RsqRange=RsqRange*RsqRange
							Sij = pos(:,I) - pos(:,J)         ! distance vector between i j
							Rsqij = dot_product(Sij,Sij)                ! compute square distance
		If (I.eq.1734) then               
		print *, "I, ScaleIndex(I), J, ScaleIndex(J)",I, ScaleIndex(I), J, ScaleIndex(J) 
		print *, "i, Rsqij, RsqRange,  Itmp", i, Rsqij, RsqRange, Itmp
		endif
			If (I.eq.1734) then
		print *, "I, ScaleIndex(I), J, ScaleIndex(J)",I, ScaleIndex(I), J, ScaleIndex(J) 
		print *, "i, Rsqij, RsqRange,  Itmp", i, Rsqij, RsqRange, Itmp
		endif
							if ( Rsqij < RsqRange ) then                 ! is j to be a neighbor of i?
								if ( L > MaxListLength) goto 9999
								L=L+1
								NeighborList(L-1) = J		! The number in List is global because j is global
							endif
						endif
						J = List(J)				! The number in CellList is global
					ENDDO
				enddo
			enddo
		enddo
		Marker2(I) = L - 1
!!FH	endif
enddo
ListLength = L - 1                                ! final used length of List
print *, ListLength,' indexes in list'   ! complete report line

return                                            ! regular exit
9999 continue                                     ! here if no more room
   print *, I
   print '(/,a)','Update_List: FATAL: List too small for such a large Skin.'
   print '(a)','If you really want to use this Skin, you must increase the'
   print '(a)','value of parameter MaxPairsPerAtom in module Neighbor_List from'
   print '(i4,a)',MaxPairsPerAtom,' to something bigger, recompile and rerun.'
   stop
end subroutine Neighbor

subroutine FindSymPair
use control
integer i,j,k,L,m,cnt,cntPair,cntKept,cntIdeal, nvacancy   !nsolute
real, dimension(3,MaxPairsPerAtom) :: banl
integer,dimension(2*MaxPairsPerAtom) :: SymNei
integer,dimension(MaxPairsPerAtom) :: IndBack
INTEGER, DIMENSION(10) :: nsolute,typ
INTEGER, DIMENSION(10, 1000) :: Isolution
real, dimension(3) :: unbanl
logical FoundSymPair
Open (6, file='CheckModel.md')
!
!	Second time for output, note that the ouput format changed a little for the read in calculation program
!
print *,'Writing output file ......'
call Neighbor		! Read in and neighboring again after discarding
open(5,file=FOut)			! This time save to the output file
!write(5,'(i8,i8,i8)') scales,NAtoms,NAtoms-cntKept
!write(5,'(a80)')fip
write(5,'(a80)')ftitle
!write(5,'(i10, i10, i10, f20.10)')levfg,imcon, ntotal, deltat
write(5,'(i10, i10)')levfg,imcon
write(5,'(3f20.10)')0.5*ModelSize(1)*cell1(1),0.5*ModelSize(1)*cell1(2),0.5*ModelSize(1)*cell1(3)
write(5,'(3f20.10)')0.5*ModelSize(2)*cell1(4),0.5*ModelSize(2)*cell1(5),0.5*ModelSize(2)*cell1(6)
write(5,'(3f20.10)')0.5*ModelSize(3)*cell1(7),0.5*ModelSize(3)*cell1(8),0.5*ModelSize(3)*cell1(9)
! write(5,'(a1,f24.15,f24.15,f24.15)') 'F',ModelSize(1),ModelSize(2),ModelSize(3)
cntIdeal=0
cntKept=0
! nsolute=10    !3964   !100   !50    !350    !1300      !670(441)      !1000(662)   !41(26)   !350     !350      !2500    !1250       !5172      !40
nvacancy=0   !10
print *, "NAtoms", NAtoms
read(1,*)m
Do ii=1,m
read(1,*)nsolute(ii),typ(ii)      
!!!  randomly introduce some solutes in the cell
!	   rm=2657863.0			 !ʼ
!	   print *, "*1, rm",rm
        rm=2657863
!        rm=26578630          ! Fan, 6/13/06 no second type atom appear
!         rm=265786             only 2 occurred
!          rm=50000           !   only 3 happened
	   j=1
!	   do while(j<nsolute)
       do while(j<nsolute(ii))
!	  Print *, "*2, j",j
	      call random(q,rm)		 !α򣬲01֮q
!	      q=1.0+q*(nx*ny*nz-1)
!      Print *, "*3, q", q
          q=1.0+q*(Natoms-1)
	if (q.lt.NAtoms)then
!	   if (AtomTypeIndex(int(q)).gt.1) then    !F   4/3/07
!		 if (ScaleIndex(int(q)).eq.1)then
		   ISolution(ii,j)=int(q)
           AtomTypeIndex(int(q))=typ(ii)
	   	  print *, "Ta2, ii, j, q, ISolution(ii,j), AtomTypeIndex", ii, j, q, ISolution(ii,j), AtomTypeIndex(int(q))
		  write (6,*)"Ta2, ii, j, q, ISolution(j), AtomTypeIndex", ii, j, q, ISolution(ii,j), AtomTypeIndex(int(q))
!	     endif
!	   endif
!		     AtomTypeIndex(int(q))=2
!		  if (coordinate(int(q),5).eq.1.0) then
!		     coordinate(int(q),5)=2
!		  if (coordinate(int(q),4).eq.1.0) then
!		     coordinate(int(q),4)=2
			 j=j+1
! print *, "Ta2, j", j
    endif
       enddo
enddo
! print *,"Ta2"
!!!  randomly introduce some vacancies in the cell
	   j=1
	   do while(j<nvacancy)
	      call random(q,rm)		 
		      q=1.0+q*(Natoms-1)
	if (q.lt.NAtoms)then
       if (AtomTypeIndex(int(q)).eq.1) then
	   Ivacancy(j)=int(q)
	   print *, "Ta2, j, q, Ivacancy(j), AtomTypeIndex", j, q, Ivacancy (j), AtomTypeIndex(int(q))
!       write (6,*)"Ta2, j, q, Ivacancy(j), AtomTypeIndex", j, q, Ivacancy (j), AtomTypeIndex(int(q))
	   endif
!		     AtomTypeIndex(int(q))=0
!	      q=1.0+q*(nx*ny*nz-1)
!		  if (coordinate(int(q),5).eq.1.0) then
!		     coordinate(int(q),5)=0
!			  if (coordinate(int(q),4).eq.1.0) then
!		     coordinate(int(q),4)=0
			 j=j+1
    endif
       enddo

do i=1,NAtoms
!!FH	if(ScaleIndex(i)<0) then
		cntIdeal=cntIdeal+1
		cnt=0
		cntPair=0
    	If(i.eq.1734)then
!		print *,"i,Marker1(i), Marker2(i)", i, Marker1(i), Marker2(i)
	    endif 
		do L=Marker1(i),Marker2(i)
			cnt=cnt+1
			j = NeighborList(L)
    	if( I.ne.J .and. abs(ScaleIndex(I)+ScaleIndex(J)).eq.1 ) then    !!FH
			banl(:,cnt)=pos(:,j)-pos(:,i)
			IndBack(cnt)=j					! Used to trace back the global serial number
			if(cnt>1) then
				do k=1,cnt-1
					unbanl(:)=banl(:,cnt)+banl(:,k)
					if(sqrt(dot_product(unbanl,unbanl))<1.) then
						cntPair=cntPair+1
					 If (cntPair.le.100) then
						SymNei(cntPair)=IndBack(k)
						cntPair=cntPair+1
						SymNei(cntPair)=j
					endif
					endif
				enddo
			endif
		else
			        	cntPair=0
						SymNei(cntPair)=0
						cntPair=0
						SymNei(cntPair)=0
		endif
		enddo
				FoundSymPair=cntPair .ne. 0
!!!FH	  If(FoundSymPair) then
!!FH   write(5,'(f12.6,f24.15,f24.15,i5,i5)') pos(1,i),pos(2,i),pos(3,i),abs(ScaleIndex(i)),-AtomTypeIndex(i)
!!!  randomly introduce some solutes in the cell
!	   rm=2657863.0			 !ʼ
!        rm=2657863
!        rm=26578630           no second type atom appear
!         rm=265786             only 2 occurred
!          rm=50000           !   only 3 happened
Do ii=1,2
!print *,"m",m
!do while(ii<3)
	   j=1
	if((ScaleIndex(i).eq.1).and.(AtomTypeIndex(i).gt.6))then 
	   do while(j<nsolute(ii))
       If (i.eq.ISolution(ii,j))then 
!	     AtomTypeIndex(i)=2
    AtomTypeIndex(i)=typ(ii)
write (6,*)"ii,Ta2, j, ISolution(ii,j),Index", ii,j,ISolution(ii,j),AtomTypeIndex(i) 
print *, "ii, Ta2, j, ISolution(ii,j),Index", ii,j,Isolution(ii,j),AtomTypeIndex(i)
	   Endif
    	 j=j+1
!   print *, "Ta2, j", j
       enddo
!enddo
! print *,"Ta2"
!!!  randomly introduce some vacancies in the cell
!	   j=1
!	   do while(j<nvacancy)
!      if (i.eq.Ivacancy(j)) then
!		 AtomTypeIndex(i)=0
!		  write (6,*)"Ta2, j, Ivacancy(j)", j,Ivacancy(j)
!		  print *, "***, j, Ivacancy(j)", j,Ivacancy(j)
!	  endif
!			 j=j+1
!      enddo
   endif
enddo
     write(5,'(a1,I3,I14)') "m",AtomTypeIndex(i), i

!	pos(1,i)=pos(1,i)+0.25*Modelsize(1)
!	pos(2,i)=pos(2,i)+0.25*Modelsize(2)
!	pos(3,i)=pos(3,i)+0.25*Modelsize(3)
             if(ScaleIndex(i)>0) then
			   write(5,'(f20.9,f20.9,f20.9)') pos(1,i),pos(2,i),pos(3,i)
		         else
              write(5,'(f20.9,f20.9,f20.9)') pos(1,i),pos(2,i),pos(3,i)
!1/11/07   write(5,'(f24.15,f24.15,f24.15,i5,i5)') pos(1,i),pos(2,i),pos(3,i),ScaleIndex(i),AtomTypeIndex(i)
!		         else
!                write(5,'(f24.15,f24.15,f24.15,i5,i5)') pos(1,i),pos(2,i),pos(3,i),abs(ScaleIndex(i)),-AtomTypeIndex(i)
!!FH		        write(5,'(f12.6,f24.15,f24.15,i5,i5,i5)') pos(1,i),pos(2,i),pos(3,i),ScaleIndex(i),AtomTypeIndex(i), i
!!FH		         else
!!FH                write(5,'(f12.6,f24.15,f24.15,i5,i5, i5)') pos(1,i),pos(2,i),pos(3,i),abs(ScaleIndex(i)),-AtomTypeIndex(i), i
             endif
!	   write(5,'(f20.9,f20.9,f20.9)') 0.00, 0.00, 0.00
!	   write(5,'(f20.9,f20.9,f20.9)') 0.00, 0.00, 0.00
!			write(5,'(i8)') cntPair
	       If (cntPair.le.100) then
			do m=1,cntPair
!				write(5,'(i8)') SymNei(m)
			enddo
           endif
!!FH			cntKept=cntKept+1
!!!FH	  else
!!!FH          if(ScaleIndex(i)>0) then
!!!FH		write(5,'(f12.6,f24.15,f24.15,i5,i5, i5, a2)') pos(1,i),pos(2,i),pos(3,i),ScaleIndex(i),AtomTypeIndex(i), i, "No"
!!!FH          else
!!!FH        write(5,'(f12.6,f24.15,f24.15,i5,i5, i5, a2)') pos(1,i),pos(2,i),pos(3,i),abs(ScaleIndex(i)),-AtomTypeIndex(i), i, "No"
!!!FH          endif
!!!FH      Endif

enddo
close(1)
close(5)
close(6)
print *, 'Totally ', NAtoms,' atoms/particles exist'
print *, 'Totally ', cntIdeal,' ideal atoms/particles exist'
!!FH print *, cntIdeal-cntKept,' ideal atoms/particles cannot find symmetric neighbors'

end subroutine FindSymPair

SUBROUTINE UpdateLinkList
use control
INTEGER I,ICELL,IXYZ(3)

HEAD=0
List=0
DO I=1,NAtoms
	IXYZ(:)=Int( (pos(:,I)-BasePoint(:))/GridSize )
	ICELL=1+IXYZ(1)+ IXYZ(2)*MCELL(1)+ IXYZ(3)*MCELL(1)*MCELL(2)
	List(I)=HEAD(ICELL)
	HEAD(ICELL)=I
ENDDO
END SUBROUTINE UpdateLinkList

program model
!	call BasicBccCell
	call CellBCC
	call CellFCC
	call CellFe4N
        call CellRutile
     	call CellZnO
        call CellAl2O3
	call CellSi3N4
        call CellLi3PO4
        call CellLi2FeSiO4
	call Input
	call PrepMem
	call Neighbor
	call FindSymPair
end program model


!============================== 
	subroutine random(q,rm)			!01֮αqrmΪ
!==============================
	rm35=2.0**35
	rm36=2.0*rm35
	rm37=2.0*rm36
	rm=5.0*rm     !! Fan changes to the following and hope to avoid te bias
!    rm=1.6*rm      !! using this new instead of 5.0 to change the pattern on May 7, 2006 
	if (rm.ge.rm37)	rm=rm-rm37
	if (rm.ge.rm36)	rm=rm-rm36
	if (rm.ge.rm35)	rm=rm-rm35
	q=rm/rm35					
	end
