! This program use HISTORY file to calculate local stress
!Developed Wednesday March 232011 by Long He
module histo

character (len = 20) :: molecule,file_inp= "histo.inp" !input file
character (len = 20) :: file_histo ! input file containing HISTORY
!character (len = 20) :: file_histo_check = "check_histo" ! output file
character (len = 20) :: file_stress = "Mises_stresses.dat"
character (len=4), allocatable :: atname(:)
character (len=4), allocatable :: vdw_interaction(:)
character (len=4), allocatable :: vdw_atm1(:)
character (len=4), allocatable :: vdw_atm2(:)
real (kind=8), allocatable     :: vdw_par1(:)
real (kind=8), allocatable     :: vdw_par2(:)
real (kind=8), allocatable     :: vdw_par3(:)
!real (kind=8), allocatable     :: vdw_par4(:)
!real (kind=8), allocatable     :: vdw_par5(:)
real (kind=8) lx,ly,lz,m ! box dimension
real(8),allocatable :: xt(:,:),yt(:,:),zt(:,:) ! history position

real(4) AtomVal, dummy1
real :: xc1,xc2,yc1,yc2,zc1,zc2  ! box dimension
integer :: na, ia, ja, ic  ! number of atoms
integer :: nt, it, nt_start,nt_end
integer ::  rcut 
real(8) :: dx,dy,dz ! displacement
real(8) :: dxc,dyc,dzc ! Box displacement
integer , allocatable :: ins(:,:)
Integer  molnum, i, j, mxvdw, itpvdw
Character (len=10) ::  string1, string2

end module histo

Program Virial_Stress
use histo
integer ::  nc

open(99,file=file_inp,status="old",action="read")
read(99,*) nc
read(99,*) na
read(99,*) file_histo
read(99,*) nt
read(99,*) nt_start,nt_end
read(99,*) xc1,xc2,yc1,yc2,zc1,zc2
read(99,*) rcut
read(99,*) dxc,dyc,dzc
close(99)

allocate(ins(1:na,1:nt))
allocate(xt(1:na,1:nt))
allocate(yt(1:na,1:nt))
allocate(zt(1:na,1:nt))
allocate(atname(1:na))

open(10,file='FIELD', status='old', action='read')
read(10,*)
read(10,*)
read(10,*) molecule, molnum
  i=1
  do while (i.le.molnum)
     read(10,*) string1
   if(trim(string1) .eq. 'finish') then
      i=i+1
   end if
 end do
    read(10,*) string2,mxvdw
    write(*,*) "mxvdw", mxvdw
          allocate(vdw_interaction(0:mxvdw))
          allocate(vdw_atm1(1:mxvdw))
          allocate(vdw_atm2(1:mxvdw))
          allocate(vdw_par1(0:mxvdw))
          allocate(vdw_par2(0:mxvdw))
          allocate(vdw_par3(0:mxvdw))
!          allocate(vdw_par4(0:mxvdw))
!          allocate(vdw_par5(0:mxvdw))
      vdw_par1(0)=0
      vdw_par2(0)=0
      vdw_par3(0)=0
      vdw_interaction(0)='none'

    do itpvdw=1,mxvdw
       read(10,*) vdw_atm1(itpvdw),vdw_atm2(itpvdw), &
     vdw_interaction(itpvdw), vdw_par1(itpvdw), &
     vdw_par2(itpvdw), vdw_par3(itpvdw)
 !    vdw_par4(itpvdw), vdw_par5(itpvdw)
       write(*,'(a8,a8,a4,5f10.5)') vdw_atm1(itpvdw),vdw_atm2(itpvdw), &
     vdw_interaction(itpvdw), vdw_par1(itpvdw), &
     vdw_par2(itpvdw), vdw_par3(itpvdw)
!     vdw_par4(itpvdw), vdw_par5(itpvdw)
    enddo 
!       molnum=line(where:)
!   endif
!    goto 123
!  20 continue
   close (10)


!Read HISTORY file and save the position
open(888,file=file_histo,status="old",action="read")
!open(999,file='check_histo',action="write")
 do it = 1, nt
read(888,*)
read(888,*)  lx,  rrr, rrr
read(888,*)  rrr,  ly, rrr
read(888,*)  rrr, rrr,  lz
!write(*,*) lx, ly, lz
do ia= 1,na
read(888,*) atname(ia), dummy1, AtomVal, charge
!write(*,*) "it, ia, atname(ia)", it, ia, atname(ia)
read(888,*) xt(ia,it), yt(ia,it), zt(ia,it)
!read(888,*)
!read(888,*)



!   if(ins(ia,it) .eq. 1) then
 !     write(999,*) atname(ia), ia, it
  !    write(999,*) xt(ia,it), yt(ia,it), zt(ia,it)
   !endif

enddo ! ia= 1,na
enddo ! it = 1, nt

close(888)
!close(999)

open(213,file='Mises_stresses.dat',action='write')
write(213,*) "it, SigmaX (GPa), SigmaZ (GPa), Mises_I1 (GPa), VM_Stress (GPa),&
Sigmar(GPa), Sigmaz(GPa)"

do ic=1, nc
call calculate_stress
enddo

close(213)

end program Virial_Stress

subroutine calculate_stress
use histo
real (kind=8) :: dd12
integer :: ipot,error
real (kind=8) :: eee,x0,y0,z0,theta
real (kind=8) :: f(1:3)
!real (kind=8), Dimension(1:6):: Sumstress
real (kind=8), allocatable :: Mises_I1(:), Mises_I2(:), VM_Stress(:)
real (kind=8),allocatable :: stress(:,:), Sumstress(:,:), CylinStress(:,:)
real (kind=8) volume
real(8), dimension(1:3,1:3) :: A, B
real(8), dimension(1:3) :: A1, B1

! Read input file
! Adjust the boundary condition
xc1=xc1+dxc*(ic-1)
xc2=xc2+dxc*(ic-1)
yc1=yc1+dyc*(ic-1)
yc2=yc2+dyc*(ic-1)
zc1=zc1+dzc*(ic-1)
zc2=zc2+dzc*(ic-1)
write(*,*) "Box number, Box Dimension", ic, xc1,xc2,yc1,yc2,zc1,zc2
x0=(xc1+xc2)/2
y0=(yc1+yc2)/2
z0=(zc1+zc2)/2
theta=atan(y0/x0)
A(:,1) = (/cos(theta)**2,sin(theta)**2,sin(theta)*cos(theta)/)
A(:,2)=(/sin(theta)**2,cos(theta)**2,-sin(theta)*cos(theta)/)
A(:,3)=(/-sin(2*theta),sin(2*theta),cos(theta)**2-sin(theta)**2/)
B=0
call Invert(A,B,error)

! allocate the allocatable variables
allocate(stress(1:6,nt_start:nt_end))
allocate(Sumstress(1:6,nt_start:nt_end))
allocate(CylinStress(1:6,nt_start:nt_end))
allocate(Mises_I1(nt_start:nt_end))
allocate(Mises_I2(nt_start:nt_end))
allocate(VM_Stress(nt_start:nt_end))


  !scan FIELD file to get potential parameters

!open(10,file='FIELD', status='old', action='read')



stress = 0.d0


!Calculate local stress
!open(888,file=file_histo,status="old",action="read")
do it = nt_start, nt_end
  do ia= 1,na
!  if ((it.ge.nt_start).and.(it.le.nt_end)) then
ins(ia,it) = 1
!Check inside (ins(ia, it) =1)
if ((xt(ia,it).gt.xc2).or.( xt(ia,it).lt.xc1)) then
ins(ia,it) = 0
endif
if ((yt(ia,it).gt.yc2).or.(yt(ia,it).lt.yc1)) then
ins(ia,it) = 0
endif
if ((zt(ia,it).gt.zc2).or.(zt(ia,it).lt.zc1)) then
ins(ia,it) = 0
endif

  if (ins(ia,it).eq.1) then
    do ja = 1,na
    if(ia.eq.ja) cycle
! if (ins(ia,iit).ne.1) then
   dx = xt(ja,it)-xt(ia,it)
   dy = yt(ja,it)-yt(ia,it)
   dz = zt(ja,it)-zt(ia,it)
!write(*,*), dx
!dx = dx - lx*NINT(dx/lx)
!dy = dy - ly*NINT(dy/ly)
!dz = dz - lz*NINT(dz/lz)
!write(*,*), "dx NINT 2313", dx
   dd12 =sqrt( dx**2  + dy**2 + dz**2 )
 if (dd12.lt.rcut)then
       ipot = 0
! calculate interaction kind
 !write(*,*) "162 line, mxvdw", mxvdw
      do itpvdw = 1, mxvdw
 !      write(*,'(a8,a8,a4,5f10.5)') vdw_atm1(itpvdw),vdw_atm2(itpvdw), &
 !    vdw_interaction(itpvdw), vdw_par1(itpvdw), &
 !    vdw_par2(itpvdw), vdw_par3(itpvdw)
 !    vdw_par4(itpvdw), vdw_par5(itpvdw)
     if ((vdw_atm1(itpvdw).eq.atname(ia)).and.(vdw_atm2(itpvdw).eq.atname(ja))) then
        ipot = itpvdw
     endif
    if ((vdw_atm1(itpvdw).eq.atname(ja)).and.(vdw_atm2(itpvdw).eq.atname(ia))) then
        ipot = itpvdw
         endif
     enddo !itpvdw = 1,mxvdw
    
 ! if (vdw_interaction(ipot).eq."mors" .or. vdw_interaction(ipot).eq."none") then ! Morse Potential

       eee = exp(- vdw_par3(ipot)*(dd12 - vdw_par2(ipot)))
       f(1) = 2*vdw_par1(ipot)*(1-eee)*(eee)*vdw_par3(ipot)*dx/dd12
       f(2) = 2*vdw_par1(ipot)*(1-eee)*(eee)*vdw_par3(ipot)*dy/dd12
       f(3) = 2*vdw_par1(ipot)*(1-eee)*(eee)*vdw_par3(ipot)*dz/dd12
!write(*,*) xx1,yy1,zz1
!write(*,*) xx2,yy2,zz2
!write(*,*)  f(1),  f(2),  f(3)
!write(*,*) f(1),f(2),f(3),it
 !     endif !(vdw_interaction(ipot).eq."mors")
       stress(1,it) = stress(1,it) + 0.5*f(1)*dx
       stress(2,it) = stress(2,it) + 0.5*f(2)*dy
       stress(3,it) = stress(3,it) + 0.5*f(3)*dz
       stress(4,it) = stress(4,it) + 0.5*f(2)*dz
       stress(5,it) = stress(5,it) + 0.5*f(1)*dz
       stress(6,it) = stress(6,it) + 0.5*f(1)*dy
!      write(*,*) "218line it,ia, 0.5*f(1)*dx, stress(1,it)", it, ia,  0.5*f(1)*dx, stress(1,it)

 endif !(dd12.lt.rcut)

    enddo !ja = 1,na


   endif ! ins(ia,it).eq.1
!  endif !((it.ge.nt_start).and.(it.le.nt_end))
 enddo ! ia= 1,na
enddo ! it = 1, nt


!Print Stress
volume=(xc2-xc1)*(yc2-yc1)*(zc2-zc1)
write(*,*) "volume", volume

Sumstress=0.d0
Mises_I1=0.d0
Mises_I2=0.d0
VM_Stress=0.d0
CylinStress=0.d0

do it = nt_start,nt_end
!if ((it.ge.nt_start).and.(it.le.nt_end)) then
 Sumstress(1,it)=stress(1,it)/volume
 Sumstress(2,it)=stress(2,it)/volume
 Sumstress(3,it)=stress(3,it)/volume
 Sumstress(4,it)=stress(4,it)/volume
 Sumstress(5,it)=stress(5,it)/volume
 Sumstress(6,it)=stress(6,it)/volume
!endif !((it.ge.nt_start).and.(it.le.nt_end))
 Mises_I1(it)=Sumstress(1,it)+Sumstress(2,it)+Sumstress(3,it)
 Mises_I2(it)=Sumstress(1,it)*Sumstress(2,it)+Sumstress(2,it)*Sumstress(3,it) &
 +Sumstress(3,it)*Sumstress(1,it)-Sumstress(4,it)*Sumstress(4,it) &
 -Sumstress(5,it)*Sumstress(5,it)-Sumstress(6,it)*Sumstress(6,it)
 VM_Stress(it)=Sqrt(Mises_I1(it)*Mises_I1(it)-3*Mises_I2(it))

! For radial stress
A1=(/CylinStress(1,it),CylinStress(2,it),CylinStress(6,it)/)
B1=(/Sumstress(1,it),Sumstress(2,it),Sumstress(6,it)/)
A1=MatMul(B,B1)
CylinStress(3,it)=Sumstress(3,it)
CylinStress(4,it)=cos(theta)*Sumstress(4,it)-sin(theta)*Sumstress(5,it)
CylinStress(5,it)=cos(theta)*Sumstress(5,it)+sin(theta)*Sumstress(4,it)


write(213,'(I5,6(A1,f15.6))') it,char(09),Sumstress(1,it)*160.219,char(09), Sumstress(3,it)*160.219,char(09),&
Mises_I1(it)*160.219,char(09),VM_Stress(it)*160.219,char(09),CylinStress(1,it)*160.219,char(09),CylinStress(3,it)*160.219

enddo !it = 1,nt
!do i=1,6
! Sumstress(i)=Sumstress(i)/(nt_end + 1 -nt_start)
!Enddo
end subroutine calculate_stress

subroutine Invert(A,B,error)
! invert matrix A, send back as matrix B, any error is returned as error
implicit none
integer :: i, j, k, error
real(8), dimension(3,3) :: A, B, E
!real(8), dimension(2,2) :: D
! B = A^-1 = adjugate(A)/det(A)
! Cij = (-1)"i+j" * Mij
! adj(A) = C"T"
!
! below is from wikipedia
!      [a b c]-1  1[A B C]T  1[A D G]
! A^-1=[d e f]  = -[D E F] = -[B E H]
!      [g h k]    Z[G H K]   Z[C F K]
!
! Z = det(A) = aA+bB+cC = a(ek-fh)+b(fg-dk)+c(dh-eg)
!
B(1,1)=(A(2,2)*A(3,3))-(A(2,3)*A(3,2)) ! A=(ek-fh)
B(1,2)=(A(1,3)*A(3,2))-(A(1,2)*A(3,3)) ! D=(ch-bk)
B(1,3)=(A(1,2)*A(2,3))-(A(1,3)*A(2,2)) ! G=(bf-ce)
B(2,1)=(A(2,3)*A(3,1))-(A(2,1)*A(3,3)) ! B=(fg-dk)
B(2,2)=(A(1,1)*A(3,3))-(A(1,3)*A(3,1)) ! E=(ak-cj)
B(2,3)=(A(1,3)*A(2,1))-(A(1,1)*A(2,3)) ! H=(cd-af)
B(3,1)=(A(2,1)*A(3,2))-(A(2,2)*A(3,1)) ! C=(dh-eg)
B(3,2)=(A(1,2)*A(3,1))-(A(1,1)*A(3,2)) ! F=(bg-ah)
B(3,3)=(A(1,1)*A(2,2))-(A(1,2)*A(2,1)) ! K=(ae-bd)

B = B/det(A,3)  ! adjugate(A)/det(A) = A^-1
!write(6,*) "# invjacobi"
!do j=1,3
! write(6,*) "# ",B(j,:)
!enddo ! end j

E = MatMul(B,A) ! this should be unity
if (det(E,3).ge.1.0000001.and.det(E,3).le.0.9999999) then
 write(0,*) "# "//char(27)//'[31m'//"invjacobi * jacobi, Failed"//char(27)//'[0m'
 do j=1,3
  write(0,*) "# ",E(j,:)
 enddo ! end j
 write(0,*) "# det: ",det(E,3)
 error=2
else
 error=0
endif

if (det(A,3).eq.0.0) then
 write(0,*) "# "//char(27)//'[31m'//"Singular matrix"//char(27)//'[0m'
 do i=1, 3
  write(0,*) "# ",A(i,:)
 enddo
 call flush(0)
! call abort
 error=1
else
 error=0
endif

contains
! determinant of 2x2 or 3x3 matrix
function det(A,n)
implicit none
integer :: n, i
real(8), dimension(n,n) :: A
real(8) :: det0, det

if (n.eq.2) then
 det= (A(1,1)*A(2,2)) - (A(1,2)*A(2,1))
elseif (n.eq.3) then
 det= (A(1,1)*A(2,2)*A(3,3)) + (A(1,2)*A(2,3)*A(3,1)) + (A(1,3)*A(2,1)*A(3,2)) - &
       (A(1,1)*A(2,3)*A(3,2)) - (A(1,2)*A(2,1)*A(3,3)) - (A(1,3)*A(2,2)*A(3,1))
! Z = det(A) = aA+bB+cC = a(ek-fh)+b(fg-dk)+c(dh-eg)
! det = (A(1,1)*((A(2,2)*A(3,3))-(A(2,3)*A(3,2)))) + &
!       (A(1,2)*((A(2,3)*A(3,1))-(A(2,1)*A(3,3)))) + &
!       (A(1,3)*((A(2,1)*A(3,2))-(A(2,2)*A(3,1)))) 
! if (det0.ne.det) write(0,*) "# determinant problem: ", det0, det
else
 write(0,*) "# trying to find determinant of ",n,"x",n,"matrix, can only use 2x2 and 3x3"
 call exit
endif
!if (det.le.0.0) then
! write(0,*) "Warning: singular matrix A "
! do i=1, n
!  write(0,*) A(i,:)
! enddo
!endif

end function det
end subroutine Invert
