
	Program Extended_CFG_converter

    character*80     :: Source_file     !  Name of the source file: *.MD  
    character*80     :: Object_file     !  Name of the Output file: *.cfg
!    character*80     :: Model_file     !  Name of the Output file: *.cfg
    character*4   AtomName,AccVel,frame,old      !  Name of the Atoms =C,Fe
    character*8      :: dummy,Ntotal
    Integer levcfg,imcon
    Integer     Scale,AtomId,lis,rcl,Scales,Num_Particles,Num_atoms,I,J,IFlag,frm,numfrm
	Real(4)  AtomVal, dummy1, dummy2,charge,A, area, rFe, rAl, Pi, rP, rO, rSi, rSn, rLi, rMn, rCo, rNi
	Real(4), dimension(1) :: VM_Stress,ene_pot,ene_kin
	Real(4), dimension(3) :: XYZ,Boxsize
	Real(4), dimension(3) :: Vel, Force, NormalStress, ShearStress, AverageStress
	Real(4), dimension(3,3) :: H0
        Real(4), dimension(6):: Domain

if(iargc().ne.(3))then
write(*,*) "arguments are [Ntotal] [CONFIGFile] [cfgFile]"
call exit
end if
call getarg(1, Ntotal)
call getarg(2, Source_file)
call getarg(3, Object_file)
read(Ntotal,'(i8)') na 

	lis=len_trim(Source_file)
	open (unit=2, file=Source_file(1:lis), status='old', & 
	      action='read')   !Open Source Data file
        read(2,*) 
        read(2,*) levcfg, imcon
        read(2,*) BoxSize(1),dummy1,dummy2
        read(2,*) dummy1,BoxSize(2),dummy2
        read(2,*) dummy1,dummy2,BoxSize(3)

! Write data to the object file
open(unit=4,file='conf.xyz',status='unknown',action='write')
write(4,*) na
write(4,*) "CONFIG Positions"

  lis=len_trim(Object_file)
    open(unit=3,file=Object_file(1:lis),status='unknown', &
     action='write')        ! open Output Data file
 

	WRITE(3,'(a21,I8)') 'Number of particles =',na
	A=1.0  !Angstrom
	WRITE(3,'(a4,f5.2,a30)') 'A = ',A,' Angstrom (basic length-scale)'

	H0(1,1)=Boxsize(1) 
	H0(1,2)=0.0
	H0(1,3)=0.0

	H0(2,1)=0.0
	H0(2,2)=Boxsize(2)
	H0(2,3)=0.0

	H0(3,1)=0.0
	H0(3,2)=0.0
	H0(3,3)=Boxsize(3)

!	WRITE(3,'(a9,f15.11,a2)') 'H0(1,1) =',H0(1,1),' A'
    WRITE(3,'(a9,f15.11,a2)') 'H0(1,1) =',H0(1,1),' A'
  	WRITE(3,'(a9,f15.11,a2)') 'H0(1,2) =',H0(1,2),' A'
	WRITE(3,'(a9,f15.11,a2)') 'H0(1,3) =',H0(1,3),' A'
!	WRITE(3,*) "# (requited) this is the supercell's 1st edge, in A"

	WRITE(3,'(a9,f15.11,a2)') 'H0(2,1) =',H0(2,1),' A'
	WRITE(3,'(a9,f15.11,a2)') 'H0(2,2) =',H0(2,2),' A'
	WRITE(3,'(a9,f15.11,a2)') 'H0(2,3) =',H0(2,3),' A'
!	WRITE(3,*) "# (requited) this is the supercell's 2nd edge, in A"

	WRITE(3,'(a9,f15.11,a2)') 'H0(3,1) =',H0(3,1),' A'
	WRITE(3,'(a9,f15.11,a2)') 'H0(3,2) =',H0(3,2),' A'
	WRITE(3,'(a9,f15.11,a2)') 'H0(3,3) =',H0(3,3),' A'
!	WRITE(3,*) "# (requited) this is the supercell's 3rd edge, in A"

	WRITE(3,'(a13)') '.NO_VELOCITY.'    ! If do not need Velocity, write this line.
	WRITE(3,'(a15)') 'entry_count = 3' ! total entries =11 
!	WRITE(3,'(a36)') 'auxiliary[0]= Stress x [reduced unit]'
!	WRITE(3,'(a36)') 'auxiliary[1]= Stress y [reduced unit]'
!	WRITE(3,'(a36)') 'auxiliary[2]= Stress z [reduced unit]'
!	WRITE(3,*) 'auxiliary[2]= s11  [reduced unit]'
!	WRITE(3,*) 'auxiliary[3]= s22  [reduced unit]'
!	WRITE(3,*) 'auxiliary[4]= s12  [reduced unit]'
!	WRITE(3,*) 'auxiliary[5]= hydro [reduced unit]'
!!	WRITE(3,*) 'auxiliary[6]= mise  [reduced unit]'
!	WRITE(3,*) 'auxiliary[7]= Lmin  [reduced unit]'
    DO I=1,na        ! read all C atoms first 
   read(2,*) AtomName, dummy1
   read(2,*) XYZ
                if(AtomName.eq.'O') then
                AtomVal=15.99
                else if(AtomName.eq.'P') then
                AtomVal=30.97
                else if(AtomName.eq.'Li') then
                AtomVal=6.94
                else if(AtomName.eq.'Sn') then
                AtomVal=118.69
                else
                write(*,*) "modify code to include more elements (only O,Li,P,Sn available)"
               endif
        frame=AtomName

     If ((I.eq.1).or.(frame.ne.old))then
	    write(3,*)AtomVal
		   write(3,*) AtomName
	 endif
    old=AtomName
                write(4,'(a8,3f20.9)')AtomName,XYZ
    XYZ=XYZ/Boxsize+0.5  ! back to Pos(:,I) of [0,1]
!write(*,*) XYZ
                write(3,'(3f20.9)') XYZ
              if(levcfg .eq.1) then
                read(2,'(3f20.9)')vx,vy,vz
            else if(levcfg .eq.2) then
                read(2,'(3f20.9)')vx,vy,vz
                read(2,'(3f20.9)')fx,fy,fz
              endif

    enddo

    close(2)
    close(3)
    close(4)

end Program Extended_CFG_converter
