! This program use HISTORY file to calculate local stress
!Developed Wednesday March 232011 by Long He
! This code is written only for HISTORY file with position, if it includes 
! velocity and force. It just needs to not comment line 119 & 120

Program Virial_Stress

character (len = 20) :: molecule,file_inp= "histo.inp" !input file
character (len = 20) :: file_histo != "HISTORY" ! input file containing HISTORY
character (len = 20) :: file_histo_check = "check_histo" ! output file
character (len = 20) :: file_stress = "Mises_stresses.dat"
character (len=4), allocatable :: atname(:)
character (len=4), allocatable :: vdw_interaction(:)
character (len=4), allocatable :: vdw_atm1(:)
character (len=4), allocatable :: vdw_atm2(:)
real (kind=8), allocatable     :: vdw_par1(:)
real (kind=8), allocatable     :: vdw_par2(:)
real (kind=8), allocatable     :: vdw_par3(:)
!real (kind=8), allocatable     :: vdw_par4(:)
!real (kind=8), allocatable     :: vdw_par5(:)
integer :: na, ia, ja  ! number of atoms
integer :: nt, it, nt_start,nt_end
integer ::  rcut 
real (kind=8) lx,ly,lz,m ! box dimension
real(8),allocatable :: xt(:,:),yt(:,:),zt(:,:) ! history position
real(8) :: dx,dy,dz ! displacement
real (kind=8),allocatable :: stress(:,:)
real (kind=8) volume
real(4) AtomVal, dummy1
real :: xc1,xc2,yc1,yc2,zc1,zc2  ! box dimension
integer , allocatable :: ins(:,:)
Integer  molnum, i, j, mxvdw, itpvdw
Character (len=10) ::  string1, string2
real (kind=8) :: dd12
integer :: ipot
real (kind=8) :: eee
real (kind=8) :: f(1:3)
real (kind=8), Dimension(1:6):: Sumstress
real (kind=8) :: Mises_I1, Mises_I2, VM_Stress

! Read input file
open(99,file=file_inp,status="old",action="read")
read(99,*) na
read(99,*) file_histo
read(99,*) nt
read(99,*) nt_start,nt_end
read(99,*) xc1,xc2,yc1,yc2,zc1,zc2
read(99,*) rcut
close(99)
! allocate the allocatable variables
allocate(ins(1:na,1:nt))
allocate(xt(1:na,1:nt))
allocate(yt(1:na,1:nt))
allocate(zt(1:na,1:nt))
allocate(stress(1:6,nt_start:nt_end))
allocate(atname(1:na))


  !scan FIELD file to get potential parameters
open(10,file='FIELD', status='old', action='read')
read(10,*)
read(10,*)
read(10,*) molecule, molnum
  i=1
  do while (i.le.molnum)
     read(10,*) string1
   if(trim(string1) .eq. 'finish') then
      i=i+1
   end if
 end do
    read(10,*) string2,mxvdw
    write(*,*) "mxvdw", mxvdw
          allocate(vdw_interaction(0:mxvdw))
          allocate(vdw_atm1(1:mxvdw))
          allocate(vdw_atm2(1:mxvdw))
          allocate(vdw_par1(0:mxvdw))
          allocate(vdw_par2(0:mxvdw))
          allocate(vdw_par3(0:mxvdw))
!          allocate(vdw_par4(0:mxvdw))
!          allocate(vdw_par5(0:mxvdw))
      vdw_par1(0)=0
      vdw_par2(0)=0
      vdw_par3(0)=0
      vdw_interaction(0)='none'

    do itpvdw=1,mxvdw
       read(10,*) vdw_atm1(itpvdw),vdw_atm2(itpvdw), &
     vdw_interaction(itpvdw), vdw_par1(itpvdw), &
     vdw_par2(itpvdw), vdw_par3(itpvdw)
 !    vdw_par4(itpvdw), vdw_par5(itpvdw)
       write(*,'(a8,a8,a4,5f10.5)') vdw_atm1(itpvdw),vdw_atm2(itpvdw), &
     vdw_interaction(itpvdw), vdw_par1(itpvdw), &
     vdw_par2(itpvdw), vdw_par3(itpvdw)
!     vdw_par4(itpvdw), vdw_par5(itpvdw)
    enddo 
!       molnum=line(where:)
!   endif
!    goto 123
!  20 continue
   close (10)

!open(10,file='FIELD', status='old', action='read')



!Read HISTORY file and save the position
open(888,file=file_histo,status="old",action="read")
open(999,file='check_histo',action="write")
 do it = 1, nt
read(888,*)
read(888,*)  lx,  rrr, rrr
read(888,*)  rrr,  ly, rrr
read(888,*)  rrr, rrr,  lz
!write(*,*) lx, ly, lz
do ia= 1,na
read(888,*) atname(ia), dummy1, AtomVal, charge
!write(*,*) "it, ia, atname(ia)", it, ia, atname(ia)
read(888,*) xt(ia,it), yt(ia,it), zt(ia,it)
read(888,*)  !if control is 3 for HISTORY, this two lines must be used.
read(888,*)


ins(ia,it) = 1
!Check inside (ins(ia, it) =1)
if ((xt(ia,it).gt.xc2).or.( xt(ia,it).lt.xc1)) then
ins(ia,it) = 0
endif
if ((yt(ia,it).gt.yc2).or.(yt(ia,it).lt.yc1)) then
ins(ia,it) = 0
endif
if ((zt(ia,it).gt.zc2).or.(zt(ia,it).lt.zc1)) then
ins(ia,it) = 0
endif

   if(ins(ia,it) .eq. 1) then
      write(999,*) atname(ia), ia, it
      write(999,*) xt(ia,it), yt(ia,it), zt(ia,it)
   endif

enddo ! ia= 1,na
enddo ! it = 1, nt

close(888)
close(999)

stress = 0.d0


!Calculate local stress
!open(888,file=file_histo,status="old",action="read")
do it = nt_start, nt_end
  do ia= 1,na
!  if ((it.ge.nt_start).and.(it.le.nt_end)) then
  if (ins(ia,it).eq.1) then
    do ja = 1,na
    if(ia.eq.ja) cycle
! if (ins(ia,iit).ne.1) then
   dx = xt(ja,it)-xt(ia,it)
   dy = yt(ja,it)-yt(ia,it)
   dz = zt(ja,it)-zt(ia,it)
!write(*,*), dx
!dx = dx - lx*NINT(dx/lx)
!dy = dy - ly*NINT(dy/ly)
!dz = dz - lz*NINT(dz/lz)
!write(*,*), "dx NINT 2313", dx
   dd12 =sqrt( dx**2  + dy**2 + dz**2 )
 if (dd12.lt.rcut)then
       ipot = 0
! calculate interaction kind
 !write(*,*) "162 line, mxvdw", mxvdw
      do itpvdw = 1, mxvdw
 !      write(*,'(a8,a8,a4,5f10.5)') vdw_atm1(itpvdw),vdw_atm2(itpvdw), &
 !    vdw_interaction(itpvdw), vdw_par1(itpvdw), &
 !    vdw_par2(itpvdw), vdw_par3(itpvdw)
 !    vdw_par4(itpvdw), vdw_par5(itpvdw)
     if ((vdw_atm1(itpvdw).eq.atname(ia)).and.(vdw_atm2(itpvdw).eq.atname(ja))) then
        ipot = itpvdw
     endif
    if ((vdw_atm1(itpvdw).eq.atname(ja)).and.(vdw_atm2(itpvdw).eq.atname(ia))) then
        ipot = itpvdw
         endif
     enddo !itpvdw = 1,mxvdw
    
 ! if (vdw_interaction(ipot).eq."mors" .or. vdw_interaction(ipot).eq."none") then ! Morse Potential

       eee = exp(- vdw_par3(ipot)*(dd12 - vdw_par2(ipot)))
       f(1) = 2*vdw_par1(ipot)*(1-eee)*(eee)*vdw_par3(ipot)*dx/dd12
       f(2) = 2*vdw_par1(ipot)*(1-eee)*(eee)*vdw_par3(ipot)*dy/dd12
       f(3) = 2*vdw_par1(ipot)*(1-eee)*(eee)*vdw_par3(ipot)*dz/dd12
!write(*,*) xx1,yy1,zz1
!write(*,*) xx2,yy2,zz2
!write(*,*)  f(1),  f(2),  f(3)
!write(*,*) f(1),f(2),f(3),it
 !     endif !(vdw_interaction(ipot).eq."mors")
       stress(1,it) = stress(1,it) + 0.5*f(1)*dx
       stress(2,it) = stress(2,it) + 0.5*f(2)*dy
       stress(3,it) = stress(3,it) + 0.5*f(3)*dz
       stress(4,it) = stress(4,it) + 0.5*f(2)*dz
       stress(5,it) = stress(5,it) + 0.5*f(1)*dz
       stress(6,it) = stress(6,it) + 0.5*f(1)*dy
!      write(*,*) "218line it,ia, 0.5*f(1)*dx, stress(1,it)", it, ia,  0.5*f(1)*dx, stress(1,it)

 endif !(dd12.lt.rcut)

    enddo !ja = 1,na


   endif ! ins(ia,it).eq.1
!  endif !((it.ge.nt_start).and.(it.le.nt_end))
 enddo ! ia= 1,na
enddo ! it = 1, nt


!Print Stress
volume=(xc2-xc1)*(yc2-yc1)*(zc2-zc1)
write(*,*) "volume", volume
do i=1,6
Sumstress(i)=0.d0
Enddo

do it = nt_start,nt_end
!if ((it.ge.nt_start).and.(it.le.nt_end)) then
 Sumstress(1)=Sumstress(1)+stress(1,it)/volume
 Sumstress(2)=Sumstress(2)+stress(2,it)/volume
 Sumstress(3)=Sumstress(3)+stress(3,it)/volume
 Sumstress(4)=Sumstress(4)+stress(4,it)/volume
 Sumstress(5)=Sumstress(5)+stress(5,it)/volume
 Sumstress(6)=Sumstress(6)+stress(6,it)/volume
!endif !((it.ge.nt_start).and.(it.le.nt_end))

enddo !it = 1,nt
do i=1,6
 Sumstress(i)=Sumstress(i)/(nt_end + 1 -nt_start)
Enddo

 Mises_I1=Sumstress(1)+Sumstress(2)+Sumstress(3)
 Mises_I2=Sumstress(1)*Sumstress(2)+Sumstress(2)*Sumstress(3) &
 +Sumstress(3)*Sumstress(1)-Sumstress(4)*Sumstress(4) &
 -Sumstress(5)*Sumstress(5)-Sumstress(6)*Sumstress(6)
 VM_Stress=Sqrt(Mises_I1*Mises_I1-3*Mises_I2)

open(213,file='Mises_stresses.dat',action='write')
write(213,*) "#,SigmaX (GPa),   SigmaZ (GPa),   Mises_I1/3 (GPa),   VM_Stress (GPa)"
write(213,*) "#", Sumstress(1)*160.219, Sumstress(3)*160.219, Mises_I1*160.219/3,  VM_Stress*160.219

close(213)


end program Virial_Stress
