! This program read a STATIS  file, write the data contained in STATIS file 
! in a format that is good for several graphical program (gnuplot) 
! for instance and calculate some statistic

program ela_STAT 

implicit none

integer :: nstat_eq 
integer :: nstat   
integer :: nstpval      ! number of variable in STATIS file 
integer  :: n,k,it,ist     

real (kind=8), ALLOCATABLE   :: stpval(:,:)   
real (kind=8), ALLOCATABLE   :: time(:)
real (kind=8), ALLOCATABLE   :: mean(:),vari(:) 

character*30 namefile
character*8, ALLOCATABLE :: cname(:)

integer :: nstep_skip ! skip the first nstep_skip time step 
integer :: nstep_t    ! total numer of timesteps   
integer :: stat_every_skip ! stat every during skip 
integer :: stat_every      ! stat every after 


!!!!  read input parameter
nstep_skip = 1
nstep_t    = 15000
stat_every_skip=1
stat_every=1
nstpval=49


nstat_eq=int(nstep_skip/stat_every_skip)
nstat=int((nstep_t-nstep_skip)/stat_every)

! Allocate vector
ALLOCATE(cname(1:nstpval))
ALLOCATE(mean(1:nstpval))
ALLOCATE(vari(1:nstpval))
ALLOCATE(stpval(1:nstat+nstat_eq,1:nstpval))
ALLOCATE(time(1:nstat+nstat_eq))

call variable_name(cname,nstpval)
 
do ist=1,nstpval
  mean(ist) = 0.d0
  vari(ist) = 0.d0
enddo


! read STATIS file
namefile='STATIS'
open(99,file=namefile,action='read')
  read(99,*) 
  read(99,*)
  do it=1,nstat_eq+nstat
    read(99,'(i10,1p,e14.6,0p,i10,/,(1p,5e14.6))',ERR=10,END=10) &
    n,time(it),n,(stpval(it,k),k=1,nstpval)
  enddo
10 CONTINUE
close(99)

! write output  

namefile='POST_PROC/STATIS_ela.gnu'
open(98,file=namefile,action='write')
  do ist=1,nstpval
    do it=1,nstat+nstat_eq
      if (time(it).ne.0.0) then
        write(98,'(5e14.6)')  time(it),stpval(it,ist)
      endif
      if (it.gt.nstat_eq) then
        mean(ist) = mean(ist) + stpval(it,ist)
        vari(ist) = vari(ist) + (stpval(it,ist))**2
      endif
    enddo
    write(98,*) 
    write(98,*)
  enddo
close(98)

!write second output

namefile='POST_PROC/STATIS_ela2.gnu'
open(97,file=namefile,action='write')
  do it=1,nstat+nstat_eq
    if (time(it).ne.0.0) then
      write(97,1000) time(it), stpval(it,:)
    endif
  enddo

1000 FORMAT(63(e14.7,1x)) 

close(97)
write(6,*) '120'


! write some statistic 

namefile='POST_PROC/statistic.dat'
open(97,file=namefile,action='write')

write(97,*) 'from  FILE STATIS! ' 
write(97,*) 
write(97,*) 'number of observables  =   ', nstpval
write(97,*) 
write(97,*) ' istval      mean         vari        stand_dev   name' 
write(97,*) 

  do ist=1,nstpval
    mean(ist) = mean(ist)/nstat
    vari(ist) = vari(ist)/nstat - mean(ist)**2
    write(97,'(2x,i2,4x,3e14.6,4x,a8)') ist,mean(ist),vari(ist),   &
                                     vari(ist)**0.5,cname(ist)
  enddo

close(97)


end program ela_STAT

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
subroutine variable_name(cnome,n) 

implicit none

integer :: n,i
character*8, dimension(1:n) :: cnome

do i=1,n
  cnome(i) = '-' 
enddo

cnome(1)='ene_tot'
cnome(2)='temp'
cnome(3)='ene_conf'
cnome(4)='ene_srp'
cnome(10)='entalpy'
cnome(12)='vir_tot'
cnome(13)='vir_srp'
cnome(19)='volume'
cnome(25)='angle_cel'
cnome(23)='angle_cel'
cnome(24)='angle_cel'
cnome(27)='pressure'


end subroutine variable_name 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
