!	The program takes an instance of the dl_poly HISTORY file and converts
!	it into an extended cfg file to be read by AtomEye
!       Be sure that the HISTORY file was written with the third 'traj' control parameter=2

!       Modified from the code Ex0_CFG_converter.f90 Thursday, December 16, 2010 by Ross J. Stewart

	Program Extended_CFG_converter

    character*80     :: Source_file     !  Name of the source file: *.MD  
    character*80     :: Object_file     !  Name of the Output file: *.cfg
!    character*80     :: Model_file     !  Name of the Output file: *.cfg
    character*4   AtomName,AccVel,frame,old       !  Name of the Atoms =C,Fe
    character*8      :: dummy
    Integer     Scale,AtomId,lis,Ntotal,rcl,Scales,Num_Particles,Num_atoms,I,J,IFlag,frm,numfrm
	Real(4)  AtomVal, dummy1, dummy2,charge,A, area, rFe, rAl, Pi, rP, rO, rSi, rSn, rLi, rMn, rCo, rNi
	Real(4), dimension(1) :: VM_Stress,ene_pot,ene_kin
	Real(4), dimension(3) :: XYZ,Boxsize
	Real(4), dimension(3) :: Vel, Force, NormalStress, ShearStress, AverageStress
	Real(4), dimension(3,3) :: H0
        Real(4), dimension(6):: Domain

if(iargc().ne.(3))then
write(*,*) "arguments are [frameNum] [HistoryFile] [cfgFile]"
call exit
end if
call getarg(1, frame)
call getarg(2, Source_file)
call getarg(3, Object_file)
!write(frm,'(i4)') frame !make variable 'frame' into an integer variable 'frm'
read(frame,'(i4)') frm !make variable 'frame' into an integer variable 'frm'

  
	Vel=0.0  ! Velosity set as Zero
	lis=len_trim(Source_file)
	open (unit=2, file=Source_file(1:lis), status='old', & 
	      action='read', err=700)   !Open Source Data file
        read(2,*) dummy, numfrm, Num_atoms
!        if(frm.gt.numfrm)then
 !         write(0,*) "Specified frame number: "//frame//" out of bound: ",numfrm
  !        call exit
   !     endif
        NTotal=Num_atoms
i=0; j=0
        do i=1,(frm-1)  !number of frames to scan past
          do j=1,(NTotal*2+4)     !number of lines per frame
           read(2,*)    !scan through file to get to the right frame
          enddo
        enddo
        write(6,*) "Frame number: ", i
        write(6,*) "Line number:  ", j*i+1

        read(2,*) BoxSize(1)
write(6,*) BoxSize(1)
        read(2,*) dummy1, BoxSize(2)
read(2,*) dummy1, dummy2, BoxSize(3)

        write(6,*) "BoxSize: ", BoxSize

! Write data to the object file
 	lis=len_trim(Object_file)
    open(unit=3,file=Object_file(1:lis),status='unknown', &
     action='write',err=800)        ! open Output Data file

!	WRITE(3,'(a21,I8)') 'Number of particles =',Ntotal
!	WRITE(3,*) '# (requited) this must be the first line'
write(*,*) "Input domain range for X, Y and Z"
read(5,*) Domain
BoxSize(1)=Domain(2)-Domain(1)
BoxSize(2)=Domain(4)-Domain(3)
BoxSize(3)=Domain(6)-Domain(5)
!    A=1.0
	A=1.0  !Angstrom
	WRITE(3,'(a4,f5.2,a30)') 'A = ',A,' Angstrom (basic length-scale)'
!	WRITE(3,*) '# (optional) basic length-scale:default A=1.0 [Angstrom]'

! set H0(i,i)=Boxsize(i)
	H0(1,1)=Boxsize(1) 
	H0(1,2)=0.0
	H0(1,3)=0.0

	H0(2,1)=0.0
	H0(2,2)=Boxsize(2)
	H0(2,3)=0.0

	H0(3,1)=0.0
	H0(3,2)=0.0
	H0(3,3)=Boxsize(3)

!	WRITE(3,'(a9,f15.11,a2)') 'H0(1,1) =',H0(1,1),' A'
    WRITE(3,'(a9,f24.15,a2)') 'H0(1,1) =',H0(1,1),' A'
  	WRITE(3,'(a9,f15.11,a2)') 'H0(1,2) =',H0(1,2),' A'
	WRITE(3,'(a9,f15.11,a2)') 'H0(1,3) =',H0(1,3),' A'
!	WRITE(3,*) "# (requited) this is the supercell's 1st edge, in A"

	WRITE(3,'(a9,f15.11,a2)') 'H0(2,1) =',H0(2,1),' A'
	WRITE(3,'(a9,f15.11,a2)') 'H0(2,2) =',H0(2,2),' A'
	WRITE(3,'(a9,f15.11,a2)') 'H0(2,3) =',H0(2,3),' A'
!	WRITE(3,*) "# (requited) this is the supercell's 2nd edge, in A"

	WRITE(3,'(a9,f15.11,a2)') 'H0(3,1) =',H0(3,1),' A'
	WRITE(3,'(a9,f15.11,a2)') 'H0(3,2) =',H0(3,2),' A'
	WRITE(3,'(a9,f15.11,a2)') 'H0(3,3) =',H0(3,3),' A'
!	WRITE(3,*) "# (requited) this is the supercell's 3rd edge, in A"

	WRITE(3,'(a13)') '.NO_VELOCITY.'    ! If do not need Velocity, write this line.
	WRITE(3,'(a15)') 'entry_count = 3' ! total entries =11 
!	WRITE(3,'(a36)') 'auxiliary[0]= Stress x [reduced unit]'
!	WRITE(3,'(a36)') 'auxiliary[1]= Stress y [reduced unit]'
!	WRITE(3,'(a36)') 'auxiliary[2]= Stress z [reduced unit]'
!	WRITE(3,*) 'auxiliary[2]= s11  [reduced unit]'
!	WRITE(3,*) 'auxiliary[3]= s22  [reduced unit]'
!	WRITE(3,*) 'auxiliary[4]= s12  [reduced unit]'
!	WRITE(3,*) 'auxiliary[5]= hydro [reduced unit]'
!!	WRITE(3,*) 'auxiliary[6]= mise  [reduced unit]'
!	WRITE(3,*) 'auxiliary[7]= Lmin  [reduced unit]'

! Write the information for all of the 'C' first: 1--> Ntotal.
!	Flag='C'  ! for C atoms
!    Flag='Fe' ! for Fe atoms
!    print *, 'C or Fe ?',Flag
!    IFlag=1
        AtomName=frame
    old=AtomName
        NormalStress=0.0
        Pi=3.14159265; rAl=1.82; rFe=1.72; rP=1.26; rO=0.650; rSn=1.720
        rSi=1.460; rLi=2.050;rCo=1.670; rNi=1.620; rMn=1.790
        k=0
    DO I=1,Ntotal         ! read all C atoms first 

   read(2,*,end=600,err=900) AtomName, dummy1, AtomVal, charge
   read(2,*,end=600,err=900) XYZ
  ! read(2,*,end=600,err=900) Vel
if(XYZ(1).gt.Domain(1).and.XYZ(1).lt.Domain(2).and.XYZ(2).gt.Domain(3)&
.and.XYZ(2).lt.Domain(4).and.XYZ(3).gt.Domain(5).and.XYZ(3).lt.Domain(6)) then
   k=k+1
  ! read(2,*,end=600,err=900) Force
        frame=AtomName

!  if (AtomName.eq.'Fe') then
!        area=Pi*rFe*rFe
!  else if (AtomName.eq.'Al') then
!        area=Pi*rAl*rAl
!  else if (AtomName.eq.'O') then
!        area=Pi*rO*rO
!  else if (AtomName.eq.'P') then
!        area=Pi*rP*rP
!  else if (AtomName.eq.'Li') then
!        area=Pi*rLi*rLi
!  else if (AtomName.eq.'Sn') then
!        area=Pi*rSn*rSn
!  else if (AtomName.eq.'Si') then
!        area=Pi*rSi*rSi
!  else if (AtomName.eq.'Co') then
!        area=Pi*rCo*rCo
!  else if (AtomName.eq.'Ni') then
!        area=Pi*rNi*rNi
!  else if (AtomName.eq.'Mn') then
!        area=Pi*rMn*rMn
!  else
!       write(*,*) "Need to add atomic radius"
!       exit
! end if

 !AverageStress=AverageStress+0.5*Force(:)/area
!    read(2,*,end=600,err=900) J,XYZ,VM_Stress,ene_pot,ene_kin,Scale,AtomId
!   If (Mod(AtomId,10) .eq. 1) then
!    If ((J.gt.11793).and.(J.lt.11798)) then
!	print *, "J,XYZ", J,XYZ,VM_Stress,ene_pot,ene_kin,Scale,AtomId,IFlag
!    endif
!	If (J.eq.20460) Stop
!    If (AtomId .eq. 1) then
!	   AtomName='Al'                 !c             Mg
!	   AtomVal=26.98                 !c: 12.011,    Mg: 24.31
     If ((I.eq.1).or.(frame.ne.old))then
     !  if(AtomVal.lt.0.02)AtomVal=55.845
	    write(3,*)AtomVal
		   write(3,*) AtomName
!		IFlag=1
	 endif
    old=AtomName
!   Endif
!   If (AtomId.EQ.2) then
!	   AtomName='Cu'                   !'Fe',  "Mg"
!	   AtomVal=63.55                 !55.85
!      If (IFlag.EQ.1)then
!	   write(3,*)AtomVal
!	   Write(3,*) AtomName
!	   IFlag=2
!	   print *,"**,J,IFlag, Cu, AtomVal", J, IFlag, AtomVal
!	   write(3,*)"**,J,IFlag, Cu, AtomVal", J, IFlag, AtomVal
!	  endif               
 !  End If
  !  AtomVal=AtomVal*2**(3*(ABS(Scale)-1))
    XYZ=XYZ/Boxsize+0.5  ! back to Pos(:,I) of [0,1]

!     if (Flag .EQ. 'C' ) then
!	   WRITE(3,*) AtomVal
!	   WRITE(3,*) 'C'
!	    Flag='Fe' ! Flag for Fe
!     end if
!	WRITE(3,'(3f10.5,3f10.5)') XYZ,VM_stress,ene_pot,ene_kin !Vel
!    WRITE(3,'(3f10.5,3e15.6)') XYZ,VM_stress,ene_pot,ene_kin !Vel
!    WRITE(3,'(3f15.6,3e15.6)') XYZ,VM_stress,ene_pot,ene_kin !Vel
    WRITE(3,'(3f15.6)') XYZ   ! 0.5*Force/area
 End If
   END DO
!   write(6,*) "Average Stress in the Domain: " , AverageStress/float(k)
   write(6,'(A22,i12)') "Number of particles = ", k
	close(unit=2)
	close(unit=3)
!    print *, 'Read Iron atoms ......'
!	open (unit=2, file=Source_file(1:lis), status='old', & 
!	      action='read', err=700)   !Open Source Data file
! Write the information for 'Fe' after all of the 'C'
!    print *, 'C or Fe ?', Flag
!    DO I=1,Ntotal         ! read all C atoms first 
!    read(2,*,end=600, err=900) J,XYZ,VM_Stress,ene_pot,ene_kin,Scale,AtomId
!	If (Mod(AtomId,10) .NE. 1) then
!	   AtomName='Fe'
!	   AtomVal=55.85
!   End If
!    AtomVal=AtomVal*2**(3*(ABS(Scale)-1))
!    XYZ=XYZ/Boxsize+0.5  ! back to Pos(:,I) of [0,1]

!      if (Flag .EQ. 'Fe' ) then
!	   WRITE(3,*) AtomVal
!	   WRITE(3,*) 'Fe'
!	    Flag='other' ! Flag for others, not write again
!      end if
!	WRITE(3,'(3f15.6,3f15.6)') XYZ,VM_stress,ene_pot,ene_kin !Vel
!    WRITE(3,'(3f15.6,3e15.6)') XYZ,VM_stress,ene_pot,ene_kin !Vel
!    End If
!    END DO

!	close(unit=2)
!	close(unit=3)

600 continue
!   print*,'Read_Sample: FATAL: ',Source_file(1:lis),' is empty?'
   stop
700 continue
   print*,'Read_Sample: FATAL: ',Source_file(1:lis),' not found.'
   stop
800 continue
   print*,'Write_Sample: WARNING: cannot open ',Object_file(1:lis),' for write'
   stop
900 continue
   print*,'Read_Sample: FATAL: read error in ',Source_file(1:lis)
   close(unit=1)
   stop

   end program Extended_CFG_converter
